'''Wrapper for yices.h

Generated with:
/usr/bin/ctypesgen.py -L /usr/lib -l yices /usr/include/yices.h -o pyices/yices_lib.py

Do not modify this file.
'''

__docformat__ =  'restructuredtext'

# Begin preamble

import ctypes, os, sys
from ctypes import *

_int_types = (c_int16, c_int32)
if hasattr(ctypes, 'c_int64'):
    # Some builds of ctypes apparently do not have c_int64
    # defined; it's a pretty good bet that these builds do not
    # have 64-bit pointers.
    _int_types += (c_int64,)
for t in _int_types:
    if sizeof(t) == sizeof(c_size_t):
        c_ptrdiff_t = t
del t
del _int_types

class c_void(Structure):
    # c_void_p is a buggy return type, converting to int, so
    # POINTER(None) == c_void_p is actually written as
    # POINTER(c_void), so it can be treated as a real pointer.
    _fields_ = [('dummy', c_int)]

def POINTER(obj):
    p = ctypes.POINTER(obj)

    # Convert None to a real NULL pointer to work around bugs
    # in how ctypes handles None on 64-bit platforms
    if not isinstance(p.from_param, classmethod):
        def from_param(cls, x):
            if x is None:
                return cls()
            else:
                return x
        p.from_param = classmethod(from_param)

    return p

class UserString:
    def __init__(self, seq):
        if isinstance(seq, basestring):
            self.data = seq
        elif isinstance(seq, UserString):
            self.data = seq.data[:]
        else:
            self.data = str(seq)
    def __str__(self): return str(self.data)
    def __repr__(self): return repr(self.data)
    def __int__(self): return int(self.data)
    def __long__(self): return long(self.data)
    def __float__(self): return float(self.data)
    def __complex__(self): return complex(self.data)
    def __hash__(self): return hash(self.data)

    def __cmp__(self, string):
        if isinstance(string, UserString):
            return cmp(self.data, string.data)
        else:
            return cmp(self.data, string)
    def __contains__(self, char):
        return char in self.data

    def __len__(self): return len(self.data)
    def __getitem__(self, index): return self.__class__(self.data[index])
    def __getslice__(self, start, end):
        start = max(start, 0); end = max(end, 0)
        return self.__class__(self.data[start:end])

    def __add__(self, other):
        if isinstance(other, UserString):
            return self.__class__(self.data + other.data)
        elif isinstance(other, basestring):
            return self.__class__(self.data + other)
        else:
            return self.__class__(self.data + str(other))
    def __radd__(self, other):
        if isinstance(other, basestring):
            return self.__class__(other + self.data)
        else:
            return self.__class__(str(other) + self.data)
    def __mul__(self, n):
        return self.__class__(self.data*n)
    __rmul__ = __mul__
    def __mod__(self, args):
        return self.__class__(self.data % args)

    # the following methods are defined in alphabetical order:
    def capitalize(self): return self.__class__(self.data.capitalize())
    def center(self, width, *args):
        return self.__class__(self.data.center(width, *args))
    def count(self, sub, start=0, end=sys.maxint):
        return self.data.count(sub, start, end)
    def decode(self, encoding=None, errors=None): # XXX improve this?
        if encoding:
            if errors:
                return self.__class__(self.data.decode(encoding, errors))
            else:
                return self.__class__(self.data.decode(encoding))
        else:
            return self.__class__(self.data.decode())
    def encode(self, encoding=None, errors=None): # XXX improve this?
        if encoding:
            if errors:
                return self.__class__(self.data.encode(encoding, errors))
            else:
                return self.__class__(self.data.encode(encoding))
        else:
            return self.__class__(self.data.encode())
    def endswith(self, suffix, start=0, end=sys.maxint):
        return self.data.endswith(suffix, start, end)
    def expandtabs(self, tabsize=8):
        return self.__class__(self.data.expandtabs(tabsize))
    def find(self, sub, start=0, end=sys.maxint):
        return self.data.find(sub, start, end)
    def index(self, sub, start=0, end=sys.maxint):
        return self.data.index(sub, start, end)
    def isalpha(self): return self.data.isalpha()
    def isalnum(self): return self.data.isalnum()
    def isdecimal(self): return self.data.isdecimal()
    def isdigit(self): return self.data.isdigit()
    def islower(self): return self.data.islower()
    def isnumeric(self): return self.data.isnumeric()
    def isspace(self): return self.data.isspace()
    def istitle(self): return self.data.istitle()
    def isupper(self): return self.data.isupper()
    def join(self, seq): return self.data.join(seq)
    def ljust(self, width, *args):
        return self.__class__(self.data.ljust(width, *args))
    def lower(self): return self.__class__(self.data.lower())
    def lstrip(self, chars=None): return self.__class__(self.data.lstrip(chars))
    def partition(self, sep):
        return self.data.partition(sep)
    def replace(self, old, new, maxsplit=-1):
        return self.__class__(self.data.replace(old, new, maxsplit))
    def rfind(self, sub, start=0, end=sys.maxint):
        return self.data.rfind(sub, start, end)
    def rindex(self, sub, start=0, end=sys.maxint):
        return self.data.rindex(sub, start, end)
    def rjust(self, width, *args):
        return self.__class__(self.data.rjust(width, *args))
    def rpartition(self, sep):
        return self.data.rpartition(sep)
    def rstrip(self, chars=None): return self.__class__(self.data.rstrip(chars))
    def split(self, sep=None, maxsplit=-1):
        return self.data.split(sep, maxsplit)
    def rsplit(self, sep=None, maxsplit=-1):
        return self.data.rsplit(sep, maxsplit)
    def splitlines(self, keepends=0): return self.data.splitlines(keepends)
    def startswith(self, prefix, start=0, end=sys.maxint):
        return self.data.startswith(prefix, start, end)
    def strip(self, chars=None): return self.__class__(self.data.strip(chars))
    def swapcase(self): return self.__class__(self.data.swapcase())
    def title(self): return self.__class__(self.data.title())
    def translate(self, *args):
        return self.__class__(self.data.translate(*args))
    def upper(self): return self.__class__(self.data.upper())
    def zfill(self, width): return self.__class__(self.data.zfill(width))

class MutableString(UserString):
    """mutable string objects

    Python strings are immutable objects.  This has the advantage, that
    strings may be used as dictionary keys.  If this property isn't needed
    and you insist on changing string values in place instead, you may cheat
    and use MutableString.

    But the purpose of this class is an educational one: to prevent
    people from inventing their own mutable string class derived
    from UserString and than forget thereby to remove (override) the
    __hash__ method inherited from UserString.  This would lead to
    errors that would be very hard to track down.

    A faster and better solution is to rewrite your program using lists."""
    def __init__(self, string=""):
        self.data = string
    def __hash__(self):
        raise TypeError("unhashable type (it is mutable)")
    def __setitem__(self, index, sub):
        if index < 0:
            index += len(self.data)
        if index < 0 or index >= len(self.data): raise IndexError
        self.data = self.data[:index] + sub + self.data[index+1:]
    def __delitem__(self, index):
        if index < 0:
            index += len(self.data)
        if index < 0 or index >= len(self.data): raise IndexError
        self.data = self.data[:index] + self.data[index+1:]
    def __setslice__(self, start, end, sub):
        start = max(start, 0); end = max(end, 0)
        if isinstance(sub, UserString):
            self.data = self.data[:start]+sub.data+self.data[end:]
        elif isinstance(sub, basestring):
            self.data = self.data[:start]+sub+self.data[end:]
        else:
            self.data =  self.data[:start]+str(sub)+self.data[end:]
    def __delslice__(self, start, end):
        start = max(start, 0); end = max(end, 0)
        self.data = self.data[:start] + self.data[end:]
    def immutable(self):
        return UserString(self.data)
    def __iadd__(self, other):
        if isinstance(other, UserString):
            self.data += other.data
        elif isinstance(other, basestring):
            self.data += other
        else:
            self.data += str(other)
        return self
    def __imul__(self, n):
        self.data *= n
        return self

class String(MutableString, Union):

    _fields_ = [('raw', POINTER(c_char)),
                ('data', c_char_p)]

    def __init__(self, obj=""):
        if isinstance(obj, (str, unicode, UserString)):
            self.data = str(obj)
        else:
            self.raw = obj

    def __len__(self):
        return self.data and len(self.data) or 0

    def from_param(cls, obj):
        # Convert None or 0
        if obj is None or obj == 0:
            return cls(POINTER(c_char)())

        # Convert from String
        elif isinstance(obj, String):
            return obj

        # Convert from str
        elif isinstance(obj, str):
            return cls(obj)

        # Convert from c_char_p
        elif isinstance(obj, c_char_p):
            return obj

        # Convert from POINTER(c_char)
        elif isinstance(obj, POINTER(c_char)):
            return obj

        # Convert from raw pointer
        elif isinstance(obj, int):
            return cls(cast(obj, POINTER(c_char)))

        # Convert from object
        else:
            return String.from_param(obj._as_parameter_)
    from_param = classmethod(from_param)

def ReturnString(obj, func=None, arguments=None):
    return String.from_param(obj)

# As of ctypes 1.0, ctypes does not support custom error-checking
# functions on callbacks, nor does it support custom datatypes on
# callbacks, so we must ensure that all callbacks return
# primitive datatypes.
#
# Non-primitive return values wrapped with UNCHECKED won't be
# typechecked, and will be converted to c_void_p.
def UNCHECKED(type):
    if (hasattr(type, "_type_") and isinstance(type._type_, str)
        and type._type_ != "P"):
        return type
    else:
        return c_void_p

# ctypes doesn't have direct support for variadic functions, so we have to write
# our own wrapper class
class _variadic_function(object):
    def __init__(self,func,restype,argtypes):
        self.func=func
        self.func.restype=restype
        self.argtypes=argtypes
    def _as_parameter_(self):
        # So we can pass this variadic function as a function pointer
        return self.func
    def __call__(self,*args):
        fixed_args=[]
        i=0
        for argtype in self.argtypes:
            # Typecheck what we can
            fixed_args.append(argtype.from_param(args[i]))
            i+=1
        return self.func(*fixed_args+list(args[i:]))

# End preamble

_libs = {}
_libdirs = ['/usr/lib']

# Begin loader

# ----------------------------------------------------------------------------
# Copyright (c) 2008 David James
# Copyright (c) 2006-2008 Alex Holkner
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#  * Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#  * Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#  * Neither the name of pyglet nor the names of its
#    contributors may be used to endorse or promote products
#    derived from this software without specific prior written
#    permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# ----------------------------------------------------------------------------

import os.path, re, sys, glob
import ctypes
import ctypes.util

def _environ_path(name):
    if name in os.environ:
        return os.environ[name].split(":")
    else:
        return []

class LibraryLoader(object):
    def __init__(self):
        self.other_dirs=[]

    def load_library(self,libname):
        """Given the name of a library, load it."""
        paths = self.getpaths(libname)

        for path in paths:
            if os.path.exists(path):
                return self.load(path)

        raise ImportError("%s not found." % libname)

    def load(self,path):
        """Given a path to a library, load it."""
        try:
            # Darwin requires dlopen to be called with mode RTLD_GLOBAL instead
            # of the default RTLD_LOCAL.  Without this, you end up with
            # libraries not being loadable, resulting in "Symbol not found"
            # errors
            if sys.platform == 'darwin':
                return ctypes.CDLL(path, ctypes.RTLD_GLOBAL)
            else:
                return ctypes.cdll.LoadLibrary(path)
        except OSError,e:
            raise ImportError(e)

    def getpaths(self,libname):
        """Return a list of paths where the library might be found."""
        if os.path.isabs(libname):
            yield libname

        else:
            for path in self.getplatformpaths(libname):
                yield path

            path = ctypes.util.find_library(libname)
            if path: yield path

    def getplatformpaths(self, libname):
        return []

# Darwin (Mac OS X)

class DarwinLibraryLoader(LibraryLoader):
    name_formats = ["lib%s.dylib", "lib%s.so", "lib%s.bundle", "%s.dylib",
                "%s.so", "%s.bundle", "%s"]

    def getplatformpaths(self,libname):
        if os.path.pathsep in libname:
            names = [libname]
        else:
            names = [format % libname for format in self.name_formats]

        for dir in self.getdirs(libname):
            for name in names:
                yield os.path.join(dir,name)

    def getdirs(self,libname):
        '''Implements the dylib search as specified in Apple documentation:

        http://developer.apple.com/documentation/DeveloperTools/Conceptual/
            DynamicLibraries/Articles/DynamicLibraryUsageGuidelines.html

        Before commencing the standard search, the method first checks
        the bundle's ``Frameworks`` directory if the application is running
        within a bundle (OS X .app).
        '''

        dyld_fallback_library_path = _environ_path("DYLD_FALLBACK_LIBRARY_PATH")
        if not dyld_fallback_library_path:
            dyld_fallback_library_path = [os.path.expanduser('~/lib'),
                                          '/usr/local/lib', '/usr/lib']

        dirs = []

        if '/' in libname:
            dirs.extend(_environ_path("DYLD_LIBRARY_PATH"))
        else:
            dirs.extend(_environ_path("LD_LIBRARY_PATH"))
            dirs.extend(_environ_path("DYLD_LIBRARY_PATH"))

        dirs.extend(self.other_dirs)
        dirs.append(".")

        if hasattr(sys, 'frozen') and sys.frozen == 'macosx_app':
            dirs.append(os.path.join(
                os.environ['RESOURCEPATH'],
                '..',
                'Frameworks'))

        dirs.extend(dyld_fallback_library_path)

        return dirs

# Posix

class PosixLibraryLoader(LibraryLoader):
    _ld_so_cache = None

    def _create_ld_so_cache(self):
        # Recreate search path followed by ld.so.  This is going to be
        # slow to build, and incorrect (ld.so uses ld.so.cache, which may
        # not be up-to-date).  Used only as fallback for distros without
        # /sbin/ldconfig.
        #
        # We assume the DT_RPATH and DT_RUNPATH binary sections are omitted.

        directories = []
        for name in ("LD_LIBRARY_PATH",
                     "SHLIB_PATH", # HPUX
                     "LIBPATH", # OS/2, AIX
                     "LIBRARY_PATH", # BE/OS
                    ):
            if name in os.environ:
                directories.extend(os.environ[name].split(os.pathsep))
        directories.extend(self.other_dirs)
        directories.append(".")

        try: directories.extend([dir.strip() for dir in open('/etc/ld.so.conf')])
        except IOError: pass

        directories.extend(['/lib', '/usr/lib', '/lib64', '/usr/lib64'])

        cache = {}
        lib_re = re.compile(r'lib(.*)\.s[ol]')
        ext_re = re.compile(r'\.s[ol]$')
        for dir in directories:
            try:
                for path in glob.glob("%s/*.s[ol]*" % dir):
                    file = os.path.basename(path)

                    # Index by filename
                    if file not in cache:
                        cache[file] = path

                    # Index by library name
                    match = lib_re.match(file)
                    if match:
                        library = match.group(1)
                        if library not in cache:
                            cache[library] = path
            except OSError:
                pass

        self._ld_so_cache = cache

    def getplatformpaths(self, libname):
        if self._ld_so_cache is None:
            self._create_ld_so_cache()

        result = self._ld_so_cache.get(libname)
        if result: yield result

        path = ctypes.util.find_library(libname)
        if path: yield os.path.join("/lib",path)

# Windows

class _WindowsLibrary(object):
    def __init__(self, path):
        self.cdll = ctypes.cdll.LoadLibrary(path)
        self.windll = ctypes.windll.LoadLibrary(path)

    def __getattr__(self, name):
        try: return getattr(self.cdll,name)
        except AttributeError:
            try: return getattr(self.windll,name)
            except AttributeError:
                raise

class WindowsLibraryLoader(LibraryLoader):
    name_formats = ["%s.dll", "lib%s.dll", "%slib.dll"]

    def load_library(self, libname):
        try:
            result = LibraryLoader.load_library(self, libname)
        except ImportError:
            result = None
            if os.path.sep not in libname:
                for name in self.name_formats:
                    try:
                        result = getattr(ctypes.cdll, name % libname)
                        if result:
                            break
                    except WindowsError:
                        result = None
            if result is None:
                try:
                    result = getattr(ctypes.cdll, libname)
                except WindowsError:
                    result = None
            if result is None:
                raise ImportError("%s not found." % libname)
        return result

    def load(self, path):
        return _WindowsLibrary(path)

    def getplatformpaths(self, libname):
        if os.path.sep not in libname:
            for name in self.name_formats:
                dll_in_current_dir = os.path.abspath(name % libname)
                if os.path.exists(dll_in_current_dir):
                    yield dll_in_current_dir
                path = ctypes.util.find_library(name % libname)
                if path:
                    yield path

# Platform switching

# If your value of sys.platform does not appear in this dict, please contact
# the Ctypesgen maintainers.

loaderclass = {
    "darwin":   DarwinLibraryLoader,
    "cygwin":   WindowsLibraryLoader,
    "win32":    WindowsLibraryLoader
}

loader = loaderclass.get(sys.platform, PosixLibraryLoader)()

def add_library_search_dirs(other_dirs):
    loader.other_dirs = other_dirs

load_library = loader.load_library

del loaderclass

# End loader

add_library_search_dirs(['/usr/lib'])

# Begin libraries

_libs["yices"] = load_library("yices")

# 1 libraries
# End libraries

# No modules

__quad_t = c_longlong # /usr/include/bits/types.h: 55

__off_t = c_long # /usr/include/bits/types.h: 140

__off64_t = __quad_t # /usr/include/bits/types.h: 141

# /usr/include/bits/libio.h: 245
class struct__IO_FILE(Structure):
    pass

FILE = struct__IO_FILE # /usr/include/bits/types/FILE.h: 7

_IO_lock_t = None # /usr/include/bits/libio.h: 154

# /usr/include/bits/libio.h: 160
class struct__IO_marker(Structure):
    pass

struct__IO_marker.__slots__ = [
    '_next',
    '_sbuf',
    '_pos',
]
struct__IO_marker._fields_ = [
    ('_next', POINTER(struct__IO_marker)),
    ('_sbuf', POINTER(struct__IO_FILE)),
    ('_pos', c_int),
]

struct__IO_FILE.__slots__ = [
    '_flags',
    '_IO_read_ptr',
    '_IO_read_end',
    '_IO_read_base',
    '_IO_write_base',
    '_IO_write_ptr',
    '_IO_write_end',
    '_IO_buf_base',
    '_IO_buf_end',
    '_IO_save_base',
    '_IO_backup_base',
    '_IO_save_end',
    '_markers',
    '_chain',
    '_fileno',
    '_flags2',
    '_old_offset',
    '_cur_column',
    '_vtable_offset',
    '_shortbuf',
    '_lock',
    '_offset',
    '__pad1',
    '__pad2',
    '__pad3',
    '__pad4',
    '__pad5',
    '_mode',
    '_unused2',
]
struct__IO_FILE._fields_ = [
    ('_flags', c_int),
    ('_IO_read_ptr', String),
    ('_IO_read_end', String),
    ('_IO_read_base', String),
    ('_IO_write_base', String),
    ('_IO_write_ptr', String),
    ('_IO_write_end', String),
    ('_IO_buf_base', String),
    ('_IO_buf_end', String),
    ('_IO_save_base', String),
    ('_IO_backup_base', String),
    ('_IO_save_end', String),
    ('_markers', POINTER(struct__IO_marker)),
    ('_chain', POINTER(struct__IO_FILE)),
    ('_fileno', c_int),
    ('_flags2', c_int),
    ('_old_offset', __off_t),
    ('_cur_column', c_ushort),
    ('_vtable_offset', c_char),
    ('_shortbuf', c_char * 1),
    ('_lock', POINTER(_IO_lock_t)),
    ('_offset', __off64_t),
    ('__pad1', POINTER(None)),
    ('__pad2', POINTER(None)),
    ('__pad3', POINTER(None)),
    ('__pad4', POINTER(None)),
    ('__pad5', c_size_t),
    ('_mode', c_int),
    ('_unused2', c_char * (((15 * sizeof(c_int)) - (4 * sizeof(POINTER(None)))) - sizeof(c_size_t))),
]

term_t = c_int32 # /usr/include/yices_types.h: 29

type_t = c_int32 # /usr/include/yices_types.h: 30

# /usr/include/yices_types.h: 47
class struct_context_s(Structure):
    pass

context_t = struct_context_s # /usr/include/yices_types.h: 47

# /usr/include/yices_types.h: 48
class struct_model_s(Structure):
    pass

model_t = struct_model_s # /usr/include/yices_types.h: 48

# /usr/include/yices_types.h: 54
class struct_ctx_config_s(Structure):
    pass

ctx_config_t = struct_ctx_config_s # /usr/include/yices_types.h: 54

# /usr/include/yices_types.h: 60
class struct_param_s(Structure):
    pass

param_t = struct_param_s # /usr/include/yices_types.h: 60

enum_smt_status = c_int # /usr/include/yices_types.h: 74

smt_status_t = enum_smt_status # /usr/include/yices_types.h: 74

# /usr/include/yices_types.h: 104
class struct_term_vector_s(Structure):
    pass

struct_term_vector_s.__slots__ = [
    'capacity',
    'size',
    'data',
]
struct_term_vector_s._fields_ = [
    ('capacity', c_uint32),
    ('size', c_uint32),
    ('data', POINTER(term_t)),
]

term_vector_t = struct_term_vector_s # /usr/include/yices_types.h: 104

# /usr/include/yices_types.h: 110
class struct_type_vector_s(Structure):
    pass

struct_type_vector_s.__slots__ = [
    'capacity',
    'size',
    'data',
]
struct_type_vector_s._fields_ = [
    ('capacity', c_uint32),
    ('size', c_uint32),
    ('data', POINTER(type_t)),
]

type_vector_t = struct_type_vector_s # /usr/include/yices_types.h: 110

enum_term_constructor = c_int # /usr/include/yices_types.h: 168

term_constructor_t = enum_term_constructor # /usr/include/yices_types.h: 168

enum_yval_tag = c_int # /usr/include/yices_types.h: 223

yval_tag_t = enum_yval_tag # /usr/include/yices_types.h: 223

# /usr/include/yices_types.h: 229
class struct_yval_s(Structure):
    pass

struct_yval_s.__slots__ = [
    'node_id',
    'node_tag',
]
struct_yval_s._fields_ = [
    ('node_id', c_int32),
    ('node_tag', yval_tag_t),
]

yval_t = struct_yval_s # /usr/include/yices_types.h: 229

# /usr/include/yices_types.h: 236
class struct_yval_vector_s(Structure):
    pass

struct_yval_vector_s.__slots__ = [
    'capacity',
    'size',
    'data',
]
struct_yval_vector_s._fields_ = [
    ('capacity', c_uint32),
    ('size', c_uint32),
    ('data', POINTER(yval_t)),
]

yval_vector_t = struct_yval_vector_s # /usr/include/yices_types.h: 236

enum_yices_gen_mode = c_int # /usr/include/yices_types.h: 258

yices_gen_mode_t = enum_yices_gen_mode # /usr/include/yices_types.h: 258

enum_error_code = c_int # /usr/include/yices_types.h: 432

error_code_t = enum_error_code # /usr/include/yices_types.h: 432

# /usr/include/yices_types.h: 572
class struct_error_report_s(Structure):
    pass

struct_error_report_s.__slots__ = [
    'code',
    'line',
    'column',
    'term1',
    'type1',
    'term2',
    'type2',
    'badval',
]
struct_error_report_s._fields_ = [
    ('code', error_code_t),
    ('line', c_uint32),
    ('column', c_uint32),
    ('term1', term_t),
    ('type1', type_t),
    ('term2', term_t),
    ('type2', type_t),
    ('badval', c_int64),
]

error_report_t = struct_error_report_s # /usr/include/yices_types.h: 572

# /usr/include/yices.h: 81
try:
    yices_version = (String).in_dll(_libs['yices'], 'yices_version')
except:
    pass

# /usr/include/yices.h: 90
try:
    yices_build_arch = (String).in_dll(_libs['yices'], 'yices_build_arch')
except:
    pass

# /usr/include/yices.h: 91
try:
    yices_build_mode = (String).in_dll(_libs['yices'], 'yices_build_mode')
except:
    pass

# /usr/include/yices.h: 92
try:
    yices_build_date = (String).in_dll(_libs['yices'], 'yices_build_date')
except:
    pass

# /usr/include/yices.h: 104
if hasattr(_libs['yices'], 'yices_init'):
    yices_init = _libs['yices'].yices_init
    yices_init.argtypes = []
    yices_init.restype = None

# /usr/include/yices.h: 111
if hasattr(_libs['yices'], 'yices_exit'):
    yices_exit = _libs['yices'].yices_exit
    yices_exit.argtypes = []
    yices_exit.restype = None

# /usr/include/yices.h: 120
if hasattr(_libs['yices'], 'yices_reset'):
    yices_reset = _libs['yices'].yices_reset
    yices_reset.argtypes = []
    yices_reset.restype = None

# /usr/include/yices.h: 135
if hasattr(_libs['yices'], 'yices_free_string'):
    yices_free_string = _libs['yices'].yices_free_string
    yices_free_string.argtypes = [String]
    yices_free_string.restype = None

# /usr/include/yices.h: 158
if hasattr(_libs['yices'], 'yices_error_code'):
    yices_error_code = _libs['yices'].yices_error_code
    yices_error_code.argtypes = []
    yices_error_code.restype = error_code_t

# /usr/include/yices.h: 164
if hasattr(_libs['yices'], 'yices_error_report'):
    yices_error_report = _libs['yices'].yices_error_report
    yices_error_report.argtypes = []
    yices_error_report.restype = POINTER(error_report_t)

# /usr/include/yices.h: 170
if hasattr(_libs['yices'], 'yices_clear_error'):
    yices_clear_error = _libs['yices'].yices_clear_error
    yices_clear_error.argtypes = []
    yices_clear_error.restype = None

# /usr/include/yices.h: 183
if hasattr(_libs['yices'], 'yices_print_error'):
    yices_print_error = _libs['yices'].yices_print_error
    yices_print_error.argtypes = [POINTER(FILE)]
    yices_print_error.restype = c_int32

# /usr/include/yices.h: 192
if hasattr(_libs['yices'], 'yices_error_string'):
    yices_error_string = _libs['yices'].yices_error_string
    yices_error_string.argtypes = []
    if sizeof(c_int) == sizeof(c_void_p):
        yices_error_string.restype = ReturnString
    else:
        yices_error_string.restype = String
        yices_error_string.errcheck = ReturnString

# /usr/include/yices.h: 217
if hasattr(_libs['yices'], 'yices_init_term_vector'):
    yices_init_term_vector = _libs['yices'].yices_init_term_vector
    yices_init_term_vector.argtypes = [POINTER(term_vector_t)]
    yices_init_term_vector.restype = None

# /usr/include/yices.h: 218
if hasattr(_libs['yices'], 'yices_init_type_vector'):
    yices_init_type_vector = _libs['yices'].yices_init_type_vector
    yices_init_type_vector.argtypes = [POINTER(type_vector_t)]
    yices_init_type_vector.restype = None

# /usr/include/yices.h: 224
if hasattr(_libs['yices'], 'yices_delete_term_vector'):
    yices_delete_term_vector = _libs['yices'].yices_delete_term_vector
    yices_delete_term_vector.argtypes = [POINTER(term_vector_t)]
    yices_delete_term_vector.restype = None

# /usr/include/yices.h: 225
if hasattr(_libs['yices'], 'yices_delete_type_vector'):
    yices_delete_type_vector = _libs['yices'].yices_delete_type_vector
    yices_delete_type_vector.argtypes = [POINTER(type_vector_t)]
    yices_delete_type_vector.restype = None

# /usr/include/yices.h: 231
if hasattr(_libs['yices'], 'yices_reset_term_vector'):
    yices_reset_term_vector = _libs['yices'].yices_reset_term_vector
    yices_reset_term_vector.argtypes = [POINTER(term_vector_t)]
    yices_reset_term_vector.restype = None

# /usr/include/yices.h: 232
if hasattr(_libs['yices'], 'yices_reset_type_vector'):
    yices_reset_type_vector = _libs['yices'].yices_reset_type_vector
    yices_reset_type_vector.argtypes = [POINTER(type_vector_t)]
    yices_reset_type_vector.restype = None

# /usr/include/yices.h: 247
if hasattr(_libs['yices'], 'yices_bool_type'):
    yices_bool_type = _libs['yices'].yices_bool_type
    yices_bool_type.argtypes = []
    yices_bool_type.restype = type_t

# /usr/include/yices.h: 248
if hasattr(_libs['yices'], 'yices_int_type'):
    yices_int_type = _libs['yices'].yices_int_type
    yices_int_type.argtypes = []
    yices_int_type.restype = type_t

# /usr/include/yices.h: 249
if hasattr(_libs['yices'], 'yices_real_type'):
    yices_real_type = _libs['yices'].yices_real_type
    yices_real_type.argtypes = []
    yices_real_type.restype = type_t

# /usr/include/yices.h: 263
if hasattr(_libs['yices'], 'yices_bv_type'):
    yices_bv_type = _libs['yices'].yices_bv_type
    yices_bv_type.argtypes = [c_uint32]
    yices_bv_type.restype = type_t

# /usr/include/yices.h: 274
if hasattr(_libs['yices'], 'yices_new_scalar_type'):
    yices_new_scalar_type = _libs['yices'].yices_new_scalar_type
    yices_new_scalar_type.argtypes = [c_uint32]
    yices_new_scalar_type.restype = type_t

# /usr/include/yices.h: 280
if hasattr(_libs['yices'], 'yices_new_uninterpreted_type'):
    yices_new_uninterpreted_type = _libs['yices'].yices_new_uninterpreted_type
    yices_new_uninterpreted_type.argtypes = []
    yices_new_uninterpreted_type.restype = type_t

# /usr/include/yices.h: 298
if hasattr(_libs['yices'], 'yices_tuple_type'):
    yices_tuple_type = _libs['yices'].yices_tuple_type
    yices_tuple_type.argtypes = [c_uint32, POINTER(type_t)]
    yices_tuple_type.restype = type_t

# /usr/include/yices.h: 311
if hasattr(_libs['yices'], 'yices_tuple_type1'):
    yices_tuple_type1 = _libs['yices'].yices_tuple_type1
    yices_tuple_type1.argtypes = [type_t]
    yices_tuple_type1.restype = type_t

# /usr/include/yices.h: 312
if hasattr(_libs['yices'], 'yices_tuple_type2'):
    yices_tuple_type2 = _libs['yices'].yices_tuple_type2
    yices_tuple_type2.argtypes = [type_t, type_t]
    yices_tuple_type2.restype = type_t

# /usr/include/yices.h: 313
if hasattr(_libs['yices'], 'yices_tuple_type3'):
    yices_tuple_type3 = _libs['yices'].yices_tuple_type3
    yices_tuple_type3.argtypes = [type_t, type_t, type_t]
    yices_tuple_type3.restype = type_t

# /usr/include/yices.h: 335
if hasattr(_libs['yices'], 'yices_function_type'):
    yices_function_type = _libs['yices'].yices_function_type
    yices_function_type.argtypes = [c_uint32, POINTER(type_t), type_t]
    yices_function_type.restype = type_t

# /usr/include/yices.h: 346
if hasattr(_libs['yices'], 'yices_function_type1'):
    yices_function_type1 = _libs['yices'].yices_function_type1
    yices_function_type1.argtypes = [type_t, type_t]
    yices_function_type1.restype = type_t

# /usr/include/yices.h: 347
if hasattr(_libs['yices'], 'yices_function_type2'):
    yices_function_type2 = _libs['yices'].yices_function_type2
    yices_function_type2.argtypes = [type_t, type_t, type_t]
    yices_function_type2.restype = type_t

# /usr/include/yices.h: 348
if hasattr(_libs['yices'], 'yices_function_type3'):
    yices_function_type3 = _libs['yices'].yices_function_type3
    yices_function_type3.argtypes = [type_t, type_t, type_t, type_t]
    yices_function_type3.restype = type_t

# /usr/include/yices.h: 368
if hasattr(_libs['yices'], 'yices_type_is_bool'):
    yices_type_is_bool = _libs['yices'].yices_type_is_bool
    yices_type_is_bool.argtypes = [type_t]
    yices_type_is_bool.restype = c_int32

# /usr/include/yices.h: 369
if hasattr(_libs['yices'], 'yices_type_is_int'):
    yices_type_is_int = _libs['yices'].yices_type_is_int
    yices_type_is_int.argtypes = [type_t]
    yices_type_is_int.restype = c_int32

# /usr/include/yices.h: 370
if hasattr(_libs['yices'], 'yices_type_is_real'):
    yices_type_is_real = _libs['yices'].yices_type_is_real
    yices_type_is_real.argtypes = [type_t]
    yices_type_is_real.restype = c_int32

# /usr/include/yices.h: 371
if hasattr(_libs['yices'], 'yices_type_is_arithmetic'):
    yices_type_is_arithmetic = _libs['yices'].yices_type_is_arithmetic
    yices_type_is_arithmetic.argtypes = [type_t]
    yices_type_is_arithmetic.restype = c_int32

# /usr/include/yices.h: 372
if hasattr(_libs['yices'], 'yices_type_is_bitvector'):
    yices_type_is_bitvector = _libs['yices'].yices_type_is_bitvector
    yices_type_is_bitvector.argtypes = [type_t]
    yices_type_is_bitvector.restype = c_int32

# /usr/include/yices.h: 373
if hasattr(_libs['yices'], 'yices_type_is_tuple'):
    yices_type_is_tuple = _libs['yices'].yices_type_is_tuple
    yices_type_is_tuple.argtypes = [type_t]
    yices_type_is_tuple.restype = c_int32

# /usr/include/yices.h: 374
if hasattr(_libs['yices'], 'yices_type_is_function'):
    yices_type_is_function = _libs['yices'].yices_type_is_function
    yices_type_is_function.argtypes = [type_t]
    yices_type_is_function.restype = c_int32

# /usr/include/yices.h: 375
if hasattr(_libs['yices'], 'yices_type_is_scalar'):
    yices_type_is_scalar = _libs['yices'].yices_type_is_scalar
    yices_type_is_scalar.argtypes = [type_t]
    yices_type_is_scalar.restype = c_int32

# /usr/include/yices.h: 376
if hasattr(_libs['yices'], 'yices_type_is_uninterpreted'):
    yices_type_is_uninterpreted = _libs['yices'].yices_type_is_uninterpreted
    yices_type_is_uninterpreted.argtypes = [type_t]
    yices_type_is_uninterpreted.restype = c_int32

# /usr/include/yices.h: 388
if hasattr(_libs['yices'], 'yices_test_subtype'):
    yices_test_subtype = _libs['yices'].yices_test_subtype
    yices_test_subtype.argtypes = [type_t, type_t]
    yices_test_subtype.restype = c_int32

# /usr/include/yices.h: 403
if hasattr(_libs['yices'], 'yices_bvtype_size'):
    yices_bvtype_size = _libs['yices'].yices_bvtype_size
    yices_bvtype_size.argtypes = [type_t]
    yices_bvtype_size.restype = c_uint32

# /usr/include/yices.h: 417
if hasattr(_libs['yices'], 'yices_scalar_type_card'):
    yices_scalar_type_card = _libs['yices'].yices_scalar_type_card
    yices_scalar_type_card.argtypes = [type_t]
    yices_scalar_type_card.restype = c_uint32

# /usr/include/yices.h: 433
if hasattr(_libs['yices'], 'yices_type_num_children'):
    yices_type_num_children = _libs['yices'].yices_type_num_children
    yices_type_num_children.argtypes = [type_t]
    yices_type_num_children.restype = c_int32

# /usr/include/yices.h: 452
if hasattr(_libs['yices'], 'yices_type_child'):
    yices_type_child = _libs['yices'].yices_type_child
    yices_type_child.argtypes = [type_t, c_int32]
    yices_type_child.restype = type_t

# /usr/include/yices.h: 471
if hasattr(_libs['yices'], 'yices_type_children'):
    yices_type_children = _libs['yices'].yices_type_children
    yices_type_children.argtypes = [type_t, POINTER(type_vector_t)]
    yices_type_children.restype = c_int32

# /usr/include/yices.h: 496
if hasattr(_libs['yices'], 'yices_true'):
    yices_true = _libs['yices'].yices_true
    yices_true.argtypes = []
    yices_true.restype = term_t

# /usr/include/yices.h: 497
if hasattr(_libs['yices'], 'yices_false'):
    yices_false = _libs['yices'].yices_false
    yices_false.argtypes = []
    yices_false.restype = term_t

# /usr/include/yices.h: 521
if hasattr(_libs['yices'], 'yices_constant'):
    yices_constant = _libs['yices'].yices_constant
    yices_constant.argtypes = [type_t, c_int32]
    yices_constant.restype = term_t

# /usr/include/yices.h: 539
if hasattr(_libs['yices'], 'yices_new_uninterpreted_term'):
    yices_new_uninterpreted_term = _libs['yices'].yices_new_uninterpreted_term
    yices_new_uninterpreted_term.argtypes = [type_t]
    yices_new_uninterpreted_term.restype = term_t

# /usr/include/yices.h: 553
if hasattr(_libs['yices'], 'yices_new_variable'):
    yices_new_variable = _libs['yices'].yices_new_variable
    yices_new_variable.argtypes = [type_t]
    yices_new_variable.restype = term_t

# /usr/include/yices.h: 578
if hasattr(_libs['yices'], 'yices_application'):
    yices_application = _libs['yices'].yices_application
    yices_application.argtypes = [term_t, c_uint32, POINTER(term_t)]
    yices_application.restype = term_t

# /usr/include/yices.h: 588
if hasattr(_libs['yices'], 'yices_application1'):
    yices_application1 = _libs['yices'].yices_application1
    yices_application1.argtypes = [term_t, term_t]
    yices_application1.restype = term_t

# /usr/include/yices.h: 589
if hasattr(_libs['yices'], 'yices_application2'):
    yices_application2 = _libs['yices'].yices_application2
    yices_application2.argtypes = [term_t, term_t, term_t]
    yices_application2.restype = term_t

# /usr/include/yices.h: 590
if hasattr(_libs['yices'], 'yices_application3'):
    yices_application3 = _libs['yices'].yices_application3
    yices_application3.argtypes = [term_t, term_t, term_t, term_t]
    yices_application3.restype = term_t

# /usr/include/yices.h: 612
if hasattr(_libs['yices'], 'yices_ite'):
    yices_ite = _libs['yices'].yices_ite
    yices_ite.argtypes = [term_t, term_t, term_t]
    yices_ite.restype = term_t

# /usr/include/yices.h: 630
if hasattr(_libs['yices'], 'yices_eq'):
    yices_eq = _libs['yices'].yices_eq
    yices_eq.argtypes = [term_t, term_t]
    yices_eq.restype = term_t

# /usr/include/yices.h: 631
if hasattr(_libs['yices'], 'yices_neq'):
    yices_neq = _libs['yices'].yices_neq
    yices_neq.argtypes = [term_t, term_t]
    yices_neq.restype = term_t

# /usr/include/yices.h: 646
if hasattr(_libs['yices'], 'yices_not'):
    yices_not = _libs['yices'].yices_not
    yices_not.argtypes = [term_t]
    yices_not.restype = term_t

# /usr/include/yices.h: 668
if hasattr(_libs['yices'], 'yices_or'):
    yices_or = _libs['yices'].yices_or
    yices_or.argtypes = [c_uint32, POINTER(term_t)]
    yices_or.restype = term_t

# /usr/include/yices.h: 669
if hasattr(_libs['yices'], 'yices_and'):
    yices_and = _libs['yices'].yices_and
    yices_and.argtypes = [c_uint32, POINTER(term_t)]
    yices_and.restype = term_t

# /usr/include/yices.h: 670
if hasattr(_libs['yices'], 'yices_xor'):
    yices_xor = _libs['yices'].yices_xor
    yices_xor.argtypes = [c_uint32, POINTER(term_t)]
    yices_xor.restype = term_t

# /usr/include/yices.h: 676
if hasattr(_libs['yices'], 'yices_or2'):
    yices_or2 = _libs['yices'].yices_or2
    yices_or2.argtypes = [term_t, term_t]
    yices_or2.restype = term_t

# /usr/include/yices.h: 677
if hasattr(_libs['yices'], 'yices_and2'):
    yices_and2 = _libs['yices'].yices_and2
    yices_and2.argtypes = [term_t, term_t]
    yices_and2.restype = term_t

# /usr/include/yices.h: 678
if hasattr(_libs['yices'], 'yices_xor2'):
    yices_xor2 = _libs['yices'].yices_xor2
    yices_xor2.argtypes = [term_t, term_t]
    yices_xor2.restype = term_t

# /usr/include/yices.h: 680
if hasattr(_libs['yices'], 'yices_or3'):
    yices_or3 = _libs['yices'].yices_or3
    yices_or3.argtypes = [term_t, term_t, term_t]
    yices_or3.restype = term_t

# /usr/include/yices.h: 681
if hasattr(_libs['yices'], 'yices_and3'):
    yices_and3 = _libs['yices'].yices_and3
    yices_and3.argtypes = [term_t, term_t, term_t]
    yices_and3.restype = term_t

# /usr/include/yices.h: 682
if hasattr(_libs['yices'], 'yices_xor3'):
    yices_xor3 = _libs['yices'].yices_xor3
    yices_xor3.argtypes = [term_t, term_t, term_t]
    yices_xor3.restype = term_t

# /usr/include/yices.h: 698
if hasattr(_libs['yices'], 'yices_iff'):
    yices_iff = _libs['yices'].yices_iff
    yices_iff.argtypes = [term_t, term_t]
    yices_iff.restype = term_t

# /usr/include/yices.h: 699
if hasattr(_libs['yices'], 'yices_implies'):
    yices_implies = _libs['yices'].yices_implies
    yices_implies.argtypes = [term_t, term_t]
    yices_implies.restype = term_t

# /usr/include/yices.h: 716
if hasattr(_libs['yices'], 'yices_tuple'):
    yices_tuple = _libs['yices'].yices_tuple
    yices_tuple.argtypes = [c_uint32, POINTER(term_t)]
    yices_tuple.restype = term_t

# /usr/include/yices.h: 723
if hasattr(_libs['yices'], 'yices_pair'):
    yices_pair = _libs['yices'].yices_pair
    yices_pair.argtypes = [term_t, term_t]
    yices_pair.restype = term_t

# /usr/include/yices.h: 724
if hasattr(_libs['yices'], 'yices_triple'):
    yices_triple = _libs['yices'].yices_triple
    yices_triple.argtypes = [term_t, term_t, term_t]
    yices_triple.restype = term_t

# /usr/include/yices.h: 744
if hasattr(_libs['yices'], 'yices_select'):
    yices_select = _libs['yices'].yices_select
    yices_select.argtypes = [c_uint32, term_t]
    yices_select.restype = term_t

# /usr/include/yices.h: 768
if hasattr(_libs['yices'], 'yices_tuple_update'):
    yices_tuple_update = _libs['yices'].yices_tuple_update
    yices_tuple_update.argtypes = [term_t, c_uint32, term_t]
    yices_tuple_update.restype = term_t

# /usr/include/yices.h: 797
if hasattr(_libs['yices'], 'yices_update'):
    yices_update = _libs['yices'].yices_update
    yices_update.argtypes = [term_t, c_uint32, POINTER(term_t), term_t]
    yices_update.restype = term_t

# /usr/include/yices.h: 805
if hasattr(_libs['yices'], 'yices_update1'):
    yices_update1 = _libs['yices'].yices_update1
    yices_update1.argtypes = [term_t, term_t, term_t]
    yices_update1.restype = term_t

# /usr/include/yices.h: 806
if hasattr(_libs['yices'], 'yices_update2'):
    yices_update2 = _libs['yices'].yices_update2
    yices_update2.argtypes = [term_t, term_t, term_t, term_t]
    yices_update2.restype = term_t

# /usr/include/yices.h: 807
if hasattr(_libs['yices'], 'yices_update3'):
    yices_update3 = _libs['yices'].yices_update3
    yices_update3.argtypes = [term_t, term_t, term_t, term_t, term_t]
    yices_update3.restype = term_t

# /usr/include/yices.h: 832
if hasattr(_libs['yices'], 'yices_distinct'):
    yices_distinct = _libs['yices'].yices_distinct
    yices_distinct.argtypes = [c_uint32, POINTER(term_t)]
    yices_distinct.restype = term_t

# /usr/include/yices.h: 863
if hasattr(_libs['yices'], 'yices_forall'):
    yices_forall = _libs['yices'].yices_forall
    yices_forall.argtypes = [c_uint32, POINTER(term_t), term_t]
    yices_forall.restype = term_t

# /usr/include/yices.h: 864
if hasattr(_libs['yices'], 'yices_exists'):
    yices_exists = _libs['yices'].yices_exists
    yices_exists.argtypes = [c_uint32, POINTER(term_t), term_t]
    yices_exists.restype = term_t

# /usr/include/yices.h: 888
if hasattr(_libs['yices'], 'yices_lambda'):
    yices_lambda = _libs['yices'].yices_lambda
    yices_lambda.argtypes = [c_uint32, POINTER(term_t), term_t]
    yices_lambda.restype = term_t

# /usr/include/yices.h: 909
if hasattr(_libs['yices'], 'yices_zero'):
    yices_zero = _libs['yices'].yices_zero
    yices_zero.argtypes = []
    yices_zero.restype = term_t

# /usr/include/yices.h: 915
if hasattr(_libs['yices'], 'yices_int32'):
    yices_int32 = _libs['yices'].yices_int32
    yices_int32.argtypes = [c_int32]
    yices_int32.restype = term_t

# /usr/include/yices.h: 916
if hasattr(_libs['yices'], 'yices_int64'):
    yices_int64 = _libs['yices'].yices_int64
    yices_int64.argtypes = [c_int64]
    yices_int64.restype = term_t

# /usr/include/yices.h: 928
if hasattr(_libs['yices'], 'yices_rational32'):
    yices_rational32 = _libs['yices'].yices_rational32
    yices_rational32.argtypes = [c_int32, c_uint32]
    yices_rational32.restype = term_t

# /usr/include/yices.h: 929
if hasattr(_libs['yices'], 'yices_rational64'):
    yices_rational64 = _libs['yices'].yices_rational64
    yices_rational64.argtypes = [c_int64, c_uint64]
    yices_rational64.restype = term_t

# /usr/include/yices.h: 956
if hasattr(_libs['yices'], 'yices_parse_rational'):
    yices_parse_rational = _libs['yices'].yices_parse_rational
    yices_parse_rational.argtypes = [String]
    yices_parse_rational.restype = term_t

# /usr/include/yices.h: 972
if hasattr(_libs['yices'], 'yices_parse_float'):
    yices_parse_float = _libs['yices'].yices_parse_float
    yices_parse_float.argtypes = [String]
    yices_parse_float.restype = term_t

# /usr/include/yices.h: 996
if hasattr(_libs['yices'], 'yices_add'):
    yices_add = _libs['yices'].yices_add
    yices_add.argtypes = [term_t, term_t]
    yices_add.restype = term_t

# /usr/include/yices.h: 997
if hasattr(_libs['yices'], 'yices_sub'):
    yices_sub = _libs['yices'].yices_sub
    yices_sub.argtypes = [term_t, term_t]
    yices_sub.restype = term_t

# /usr/include/yices.h: 998
if hasattr(_libs['yices'], 'yices_neg'):
    yices_neg = _libs['yices'].yices_neg
    yices_neg.argtypes = [term_t]
    yices_neg.restype = term_t

# /usr/include/yices.h: 999
if hasattr(_libs['yices'], 'yices_mul'):
    yices_mul = _libs['yices'].yices_mul
    yices_mul.argtypes = [term_t, term_t]
    yices_mul.restype = term_t

# /usr/include/yices.h: 1000
if hasattr(_libs['yices'], 'yices_square'):
    yices_square = _libs['yices'].yices_square
    yices_square.argtypes = [term_t]
    yices_square.restype = term_t

# /usr/include/yices.h: 1001
if hasattr(_libs['yices'], 'yices_power'):
    yices_power = _libs['yices'].yices_power
    yices_power.argtypes = [term_t, c_uint32]
    yices_power.restype = term_t

# /usr/include/yices.h: 1017
if hasattr(_libs['yices'], 'yices_sum'):
    yices_sum = _libs['yices'].yices_sum
    yices_sum.argtypes = [c_uint32, POINTER(term_t)]
    yices_sum.restype = term_t

# /usr/include/yices.h: 1036
if hasattr(_libs['yices'], 'yices_product'):
    yices_product = _libs['yices'].yices_product
    yices_product.argtypes = [c_uint32, POINTER(term_t)]
    yices_product.restype = term_t

# /usr/include/yices.h: 1060
if hasattr(_libs['yices'], 'yices_division'):
    yices_division = _libs['yices'].yices_division
    yices_division.argtypes = [term_t, term_t]
    yices_division.restype = term_t

# /usr/include/yices.h: 1087
if hasattr(_libs['yices'], 'yices_poly_int32'):
    yices_poly_int32 = _libs['yices'].yices_poly_int32
    yices_poly_int32.argtypes = [c_uint32, POINTER(c_int32), POINTER(term_t)]
    yices_poly_int32.restype = term_t

# /usr/include/yices.h: 1088
if hasattr(_libs['yices'], 'yices_poly_int64'):
    yices_poly_int64 = _libs['yices'].yices_poly_int64
    yices_poly_int64.argtypes = [c_uint32, POINTER(c_int64), POINTER(term_t)]
    yices_poly_int64.restype = term_t

# /usr/include/yices.h: 1100
if hasattr(_libs['yices'], 'yices_poly_rational32'):
    yices_poly_rational32 = _libs['yices'].yices_poly_rational32
    yices_poly_rational32.argtypes = [c_uint32, POINTER(c_int32), POINTER(c_uint32), POINTER(term_t)]
    yices_poly_rational32.restype = term_t

# /usr/include/yices.h: 1101
if hasattr(_libs['yices'], 'yices_poly_rational64'):
    yices_poly_rational64 = _libs['yices'].yices_poly_rational64
    yices_poly_rational64.argtypes = [c_uint32, POINTER(c_int64), POINTER(c_uint64), POINTER(term_t)]
    yices_poly_rational64.restype = term_t

# /usr/include/yices.h: 1130
if hasattr(_libs['yices'], 'yices_arith_eq_atom'):
    yices_arith_eq_atom = _libs['yices'].yices_arith_eq_atom
    yices_arith_eq_atom.argtypes = [term_t, term_t]
    yices_arith_eq_atom.restype = term_t

# /usr/include/yices.h: 1131
if hasattr(_libs['yices'], 'yices_arith_neq_atom'):
    yices_arith_neq_atom = _libs['yices'].yices_arith_neq_atom
    yices_arith_neq_atom.argtypes = [term_t, term_t]
    yices_arith_neq_atom.restype = term_t

# /usr/include/yices.h: 1132
if hasattr(_libs['yices'], 'yices_arith_geq_atom'):
    yices_arith_geq_atom = _libs['yices'].yices_arith_geq_atom
    yices_arith_geq_atom.argtypes = [term_t, term_t]
    yices_arith_geq_atom.restype = term_t

# /usr/include/yices.h: 1133
if hasattr(_libs['yices'], 'yices_arith_leq_atom'):
    yices_arith_leq_atom = _libs['yices'].yices_arith_leq_atom
    yices_arith_leq_atom.argtypes = [term_t, term_t]
    yices_arith_leq_atom.restype = term_t

# /usr/include/yices.h: 1134
if hasattr(_libs['yices'], 'yices_arith_gt_atom'):
    yices_arith_gt_atom = _libs['yices'].yices_arith_gt_atom
    yices_arith_gt_atom.argtypes = [term_t, term_t]
    yices_arith_gt_atom.restype = term_t

# /usr/include/yices.h: 1135
if hasattr(_libs['yices'], 'yices_arith_lt_atom'):
    yices_arith_lt_atom = _libs['yices'].yices_arith_lt_atom
    yices_arith_lt_atom.argtypes = [term_t, term_t]
    yices_arith_lt_atom.restype = term_t

# /usr/include/yices.h: 1151
if hasattr(_libs['yices'], 'yices_arith_eq0_atom'):
    yices_arith_eq0_atom = _libs['yices'].yices_arith_eq0_atom
    yices_arith_eq0_atom.argtypes = [term_t]
    yices_arith_eq0_atom.restype = term_t

# /usr/include/yices.h: 1152
if hasattr(_libs['yices'], 'yices_arith_neq0_atom'):
    yices_arith_neq0_atom = _libs['yices'].yices_arith_neq0_atom
    yices_arith_neq0_atom.argtypes = [term_t]
    yices_arith_neq0_atom.restype = term_t

# /usr/include/yices.h: 1153
if hasattr(_libs['yices'], 'yices_arith_geq0_atom'):
    yices_arith_geq0_atom = _libs['yices'].yices_arith_geq0_atom
    yices_arith_geq0_atom.argtypes = [term_t]
    yices_arith_geq0_atom.restype = term_t

# /usr/include/yices.h: 1154
if hasattr(_libs['yices'], 'yices_arith_leq0_atom'):
    yices_arith_leq0_atom = _libs['yices'].yices_arith_leq0_atom
    yices_arith_leq0_atom.argtypes = [term_t]
    yices_arith_leq0_atom.restype = term_t

# /usr/include/yices.h: 1155
if hasattr(_libs['yices'], 'yices_arith_gt0_atom'):
    yices_arith_gt0_atom = _libs['yices'].yices_arith_gt0_atom
    yices_arith_gt0_atom.argtypes = [term_t]
    yices_arith_gt0_atom.restype = term_t

# /usr/include/yices.h: 1156
if hasattr(_libs['yices'], 'yices_arith_lt0_atom'):
    yices_arith_lt0_atom = _libs['yices'].yices_arith_lt0_atom
    yices_arith_lt0_atom.argtypes = [term_t]
    yices_arith_lt0_atom.restype = term_t

# /usr/include/yices.h: 1219
if hasattr(_libs['yices'], 'yices_bvconst_uint32'):
    yices_bvconst_uint32 = _libs['yices'].yices_bvconst_uint32
    yices_bvconst_uint32.argtypes = [c_uint32, c_uint32]
    yices_bvconst_uint32.restype = term_t

# /usr/include/yices.h: 1220
if hasattr(_libs['yices'], 'yices_bvconst_uint64'):
    yices_bvconst_uint64 = _libs['yices'].yices_bvconst_uint64
    yices_bvconst_uint64.argtypes = [c_uint32, c_uint64]
    yices_bvconst_uint64.restype = term_t

# /usr/include/yices.h: 1222
if hasattr(_libs['yices'], 'yices_bvconst_int32'):
    yices_bvconst_int32 = _libs['yices'].yices_bvconst_int32
    yices_bvconst_int32.argtypes = [c_uint32, c_int32]
    yices_bvconst_int32.restype = term_t

# /usr/include/yices.h: 1223
if hasattr(_libs['yices'], 'yices_bvconst_int64'):
    yices_bvconst_int64 = _libs['yices'].yices_bvconst_int64
    yices_bvconst_int64.argtypes = [c_uint32, c_int64]
    yices_bvconst_int64.restype = term_t

# /usr/include/yices.h: 1244
if hasattr(_libs['yices'], 'yices_bvconst_zero'):
    yices_bvconst_zero = _libs['yices'].yices_bvconst_zero
    yices_bvconst_zero.argtypes = [c_uint32]
    yices_bvconst_zero.restype = term_t

# /usr/include/yices.h: 1245
if hasattr(_libs['yices'], 'yices_bvconst_one'):
    yices_bvconst_one = _libs['yices'].yices_bvconst_one
    yices_bvconst_one.argtypes = [c_uint32]
    yices_bvconst_one.restype = term_t

# /usr/include/yices.h: 1246
if hasattr(_libs['yices'], 'yices_bvconst_minus_one'):
    yices_bvconst_minus_one = _libs['yices'].yices_bvconst_minus_one
    yices_bvconst_minus_one.argtypes = [c_uint32]
    yices_bvconst_minus_one.restype = term_t

# /usr/include/yices.h: 1262
if hasattr(_libs['yices'], 'yices_bvconst_from_array'):
    yices_bvconst_from_array = _libs['yices'].yices_bvconst_from_array
    yices_bvconst_from_array.argtypes = [c_uint32, POINTER(c_int32)]
    yices_bvconst_from_array.restype = term_t

# /usr/include/yices.h: 1278
if hasattr(_libs['yices'], 'yices_parse_bvbin'):
    yices_parse_bvbin = _libs['yices'].yices_parse_bvbin
    yices_parse_bvbin.argtypes = [String]
    yices_parse_bvbin.restype = term_t

# /usr/include/yices.h: 1295
if hasattr(_libs['yices'], 'yices_parse_bvhex'):
    yices_parse_bvhex = _libs['yices'].yices_parse_bvhex
    yices_parse_bvhex.argtypes = [String]
    yices_parse_bvhex.restype = term_t

# /usr/include/yices.h: 1341
if hasattr(_libs['yices'], 'yices_bvadd'):
    yices_bvadd = _libs['yices'].yices_bvadd
    yices_bvadd.argtypes = [term_t, term_t]
    yices_bvadd.restype = term_t

# /usr/include/yices.h: 1342
if hasattr(_libs['yices'], 'yices_bvsub'):
    yices_bvsub = _libs['yices'].yices_bvsub
    yices_bvsub.argtypes = [term_t, term_t]
    yices_bvsub.restype = term_t

# /usr/include/yices.h: 1343
if hasattr(_libs['yices'], 'yices_bvneg'):
    yices_bvneg = _libs['yices'].yices_bvneg
    yices_bvneg.argtypes = [term_t]
    yices_bvneg.restype = term_t

# /usr/include/yices.h: 1344
if hasattr(_libs['yices'], 'yices_bvmul'):
    yices_bvmul = _libs['yices'].yices_bvmul
    yices_bvmul.argtypes = [term_t, term_t]
    yices_bvmul.restype = term_t

# /usr/include/yices.h: 1345
if hasattr(_libs['yices'], 'yices_bvsquare'):
    yices_bvsquare = _libs['yices'].yices_bvsquare
    yices_bvsquare.argtypes = [term_t]
    yices_bvsquare.restype = term_t

# /usr/include/yices.h: 1346
if hasattr(_libs['yices'], 'yices_bvpower'):
    yices_bvpower = _libs['yices'].yices_bvpower
    yices_bvpower.argtypes = [term_t, c_uint32]
    yices_bvpower.restype = term_t

# /usr/include/yices.h: 1348
if hasattr(_libs['yices'], 'yices_bvdiv'):
    yices_bvdiv = _libs['yices'].yices_bvdiv
    yices_bvdiv.argtypes = [term_t, term_t]
    yices_bvdiv.restype = term_t

# /usr/include/yices.h: 1349
if hasattr(_libs['yices'], 'yices_bvrem'):
    yices_bvrem = _libs['yices'].yices_bvrem
    yices_bvrem.argtypes = [term_t, term_t]
    yices_bvrem.restype = term_t

# /usr/include/yices.h: 1350
if hasattr(_libs['yices'], 'yices_bvsdiv'):
    yices_bvsdiv = _libs['yices'].yices_bvsdiv
    yices_bvsdiv.argtypes = [term_t, term_t]
    yices_bvsdiv.restype = term_t

# /usr/include/yices.h: 1351
if hasattr(_libs['yices'], 'yices_bvsrem'):
    yices_bvsrem = _libs['yices'].yices_bvsrem
    yices_bvsrem.argtypes = [term_t, term_t]
    yices_bvsrem.restype = term_t

# /usr/include/yices.h: 1352
if hasattr(_libs['yices'], 'yices_bvsmod'):
    yices_bvsmod = _libs['yices'].yices_bvsmod
    yices_bvsmod.argtypes = [term_t, term_t]
    yices_bvsmod.restype = term_t

# /usr/include/yices.h: 1354
if hasattr(_libs['yices'], 'yices_bvnot'):
    yices_bvnot = _libs['yices'].yices_bvnot
    yices_bvnot.argtypes = [term_t]
    yices_bvnot.restype = term_t

# /usr/include/yices.h: 1355
if hasattr(_libs['yices'], 'yices_bvnand'):
    yices_bvnand = _libs['yices'].yices_bvnand
    yices_bvnand.argtypes = [term_t, term_t]
    yices_bvnand.restype = term_t

# /usr/include/yices.h: 1356
if hasattr(_libs['yices'], 'yices_bvnor'):
    yices_bvnor = _libs['yices'].yices_bvnor
    yices_bvnor.argtypes = [term_t, term_t]
    yices_bvnor.restype = term_t

# /usr/include/yices.h: 1357
if hasattr(_libs['yices'], 'yices_bvxnor'):
    yices_bvxnor = _libs['yices'].yices_bvxnor
    yices_bvxnor.argtypes = [term_t, term_t]
    yices_bvxnor.restype = term_t

# /usr/include/yices.h: 1359
if hasattr(_libs['yices'], 'yices_bvshl'):
    yices_bvshl = _libs['yices'].yices_bvshl
    yices_bvshl.argtypes = [term_t, term_t]
    yices_bvshl.restype = term_t

# /usr/include/yices.h: 1360
if hasattr(_libs['yices'], 'yices_bvlshr'):
    yices_bvlshr = _libs['yices'].yices_bvlshr
    yices_bvlshr.argtypes = [term_t, term_t]
    yices_bvlshr.restype = term_t

# /usr/include/yices.h: 1361
if hasattr(_libs['yices'], 'yices_bvashr'):
    yices_bvashr = _libs['yices'].yices_bvashr
    yices_bvashr.argtypes = [term_t, term_t]
    yices_bvashr.restype = term_t

# /usr/include/yices.h: 1392
if hasattr(_libs['yices'], 'yices_bvand'):
    yices_bvand = _libs['yices'].yices_bvand
    yices_bvand.argtypes = [c_uint32, POINTER(term_t)]
    yices_bvand.restype = term_t

# /usr/include/yices.h: 1393
if hasattr(_libs['yices'], 'yices_bvor'):
    yices_bvor = _libs['yices'].yices_bvor
    yices_bvor.argtypes = [c_uint32, POINTER(term_t)]
    yices_bvor.restype = term_t

# /usr/include/yices.h: 1394
if hasattr(_libs['yices'], 'yices_bvxor'):
    yices_bvxor = _libs['yices'].yices_bvxor
    yices_bvxor.argtypes = [c_uint32, POINTER(term_t)]
    yices_bvxor.restype = term_t

# /usr/include/yices.h: 1396
if hasattr(_libs['yices'], 'yices_bvand2'):
    yices_bvand2 = _libs['yices'].yices_bvand2
    yices_bvand2.argtypes = [term_t, term_t]
    yices_bvand2.restype = term_t

# /usr/include/yices.h: 1397
if hasattr(_libs['yices'], 'yices_bvor2'):
    yices_bvor2 = _libs['yices'].yices_bvor2
    yices_bvor2.argtypes = [term_t, term_t]
    yices_bvor2.restype = term_t

# /usr/include/yices.h: 1398
if hasattr(_libs['yices'], 'yices_bvxor2'):
    yices_bvxor2 = _libs['yices'].yices_bvxor2
    yices_bvxor2.argtypes = [term_t, term_t]
    yices_bvxor2.restype = term_t

# /usr/include/yices.h: 1400
if hasattr(_libs['yices'], 'yices_bvand3'):
    yices_bvand3 = _libs['yices'].yices_bvand3
    yices_bvand3.argtypes = [term_t, term_t, term_t]
    yices_bvand3.restype = term_t

# /usr/include/yices.h: 1401
if hasattr(_libs['yices'], 'yices_bvor3'):
    yices_bvor3 = _libs['yices'].yices_bvor3
    yices_bvor3.argtypes = [term_t, term_t, term_t]
    yices_bvor3.restype = term_t

# /usr/include/yices.h: 1402
if hasattr(_libs['yices'], 'yices_bvxor3'):
    yices_bvxor3 = _libs['yices'].yices_bvxor3
    yices_bvxor3.argtypes = [term_t, term_t, term_t]
    yices_bvxor3.restype = term_t

# /usr/include/yices.h: 1429
if hasattr(_libs['yices'], 'yices_bvsum'):
    yices_bvsum = _libs['yices'].yices_bvsum
    yices_bvsum.argtypes = [c_uint32, POINTER(term_t)]
    yices_bvsum.restype = term_t

# /usr/include/yices.h: 1460
if hasattr(_libs['yices'], 'yices_bvproduct'):
    yices_bvproduct = _libs['yices'].yices_bvproduct
    yices_bvproduct.argtypes = [c_uint32, POINTER(term_t)]
    yices_bvproduct.restype = term_t

# /usr/include/yices.h: 1489
if hasattr(_libs['yices'], 'yices_shift_left0'):
    yices_shift_left0 = _libs['yices'].yices_shift_left0
    yices_shift_left0.argtypes = [term_t, c_uint32]
    yices_shift_left0.restype = term_t

# /usr/include/yices.h: 1490
if hasattr(_libs['yices'], 'yices_shift_left1'):
    yices_shift_left1 = _libs['yices'].yices_shift_left1
    yices_shift_left1.argtypes = [term_t, c_uint32]
    yices_shift_left1.restype = term_t

# /usr/include/yices.h: 1491
if hasattr(_libs['yices'], 'yices_shift_right0'):
    yices_shift_right0 = _libs['yices'].yices_shift_right0
    yices_shift_right0.argtypes = [term_t, c_uint32]
    yices_shift_right0.restype = term_t

# /usr/include/yices.h: 1492
if hasattr(_libs['yices'], 'yices_shift_right1'):
    yices_shift_right1 = _libs['yices'].yices_shift_right1
    yices_shift_right1.argtypes = [term_t, c_uint32]
    yices_shift_right1.restype = term_t

# /usr/include/yices.h: 1493
if hasattr(_libs['yices'], 'yices_ashift_right'):
    yices_ashift_right = _libs['yices'].yices_ashift_right
    yices_ashift_right.argtypes = [term_t, c_uint32]
    yices_ashift_right.restype = term_t

# /usr/include/yices.h: 1494
if hasattr(_libs['yices'], 'yices_rotate_left'):
    yices_rotate_left = _libs['yices'].yices_rotate_left
    yices_rotate_left.argtypes = [term_t, c_uint32]
    yices_rotate_left.restype = term_t

# /usr/include/yices.h: 1495
if hasattr(_libs['yices'], 'yices_rotate_right'):
    yices_rotate_right = _libs['yices'].yices_rotate_right
    yices_rotate_right.argtypes = [term_t, c_uint32]
    yices_rotate_right.restype = term_t

# /usr/include/yices.h: 1516
if hasattr(_libs['yices'], 'yices_bvextract'):
    yices_bvextract = _libs['yices'].yices_bvextract
    yices_bvextract.argtypes = [term_t, c_uint32, c_uint32]
    yices_bvextract.restype = term_t

# /usr/include/yices.h: 1540
if hasattr(_libs['yices'], 'yices_bvconcat2'):
    yices_bvconcat2 = _libs['yices'].yices_bvconcat2
    yices_bvconcat2.argtypes = [term_t, term_t]
    yices_bvconcat2.restype = term_t

# /usr/include/yices.h: 1565
if hasattr(_libs['yices'], 'yices_bvconcat'):
    yices_bvconcat = _libs['yices'].yices_bvconcat
    yices_bvconcat.argtypes = [c_uint32, POINTER(term_t)]
    yices_bvconcat.restype = term_t

# /usr/include/yices.h: 1589
if hasattr(_libs['yices'], 'yices_bvrepeat'):
    yices_bvrepeat = _libs['yices'].yices_bvrepeat
    yices_bvrepeat.argtypes = [term_t, c_uint32]
    yices_bvrepeat.restype = term_t

# /usr/include/yices.h: 1609
if hasattr(_libs['yices'], 'yices_sign_extend'):
    yices_sign_extend = _libs['yices'].yices_sign_extend
    yices_sign_extend.argtypes = [term_t, c_uint32]
    yices_sign_extend.restype = term_t

# /usr/include/yices.h: 1629
if hasattr(_libs['yices'], 'yices_zero_extend'):
    yices_zero_extend = _libs['yices'].yices_zero_extend
    yices_zero_extend.argtypes = [term_t, c_uint32]
    yices_zero_extend.restype = term_t

# /usr/include/yices.h: 1649
if hasattr(_libs['yices'], 'yices_redand'):
    yices_redand = _libs['yices'].yices_redand
    yices_redand.argtypes = [term_t]
    yices_redand.restype = term_t

# /usr/include/yices.h: 1650
if hasattr(_libs['yices'], 'yices_redor'):
    yices_redor = _libs['yices'].yices_redor
    yices_redor.argtypes = [term_t]
    yices_redor.restype = term_t

# /usr/include/yices.h: 1673
if hasattr(_libs['yices'], 'yices_redcomp'):
    yices_redcomp = _libs['yices'].yices_redcomp
    yices_redcomp.argtypes = [term_t, term_t]
    yices_redcomp.restype = term_t

# /usr/include/yices.h: 1697
if hasattr(_libs['yices'], 'yices_bvarray'):
    yices_bvarray = _libs['yices'].yices_bvarray
    yices_bvarray.argtypes = [c_uint32, POINTER(term_t)]
    yices_bvarray.restype = term_t

# /usr/include/yices.h: 1716
if hasattr(_libs['yices'], 'yices_bitextract'):
    yices_bitextract = _libs['yices'].yices_bitextract
    yices_bitextract.argtypes = [term_t, c_uint32]
    yices_bitextract.restype = term_t

# /usr/include/yices.h: 1744
if hasattr(_libs['yices'], 'yices_bveq_atom'):
    yices_bveq_atom = _libs['yices'].yices_bveq_atom
    yices_bveq_atom.argtypes = [term_t, term_t]
    yices_bveq_atom.restype = term_t

# /usr/include/yices.h: 1745
if hasattr(_libs['yices'], 'yices_bvneq_atom'):
    yices_bvneq_atom = _libs['yices'].yices_bvneq_atom
    yices_bvneq_atom.argtypes = [term_t, term_t]
    yices_bvneq_atom.restype = term_t

# /usr/include/yices.h: 1751
if hasattr(_libs['yices'], 'yices_bvge_atom'):
    yices_bvge_atom = _libs['yices'].yices_bvge_atom
    yices_bvge_atom.argtypes = [term_t, term_t]
    yices_bvge_atom.restype = term_t

# /usr/include/yices.h: 1752
if hasattr(_libs['yices'], 'yices_bvgt_atom'):
    yices_bvgt_atom = _libs['yices'].yices_bvgt_atom
    yices_bvgt_atom.argtypes = [term_t, term_t]
    yices_bvgt_atom.restype = term_t

# /usr/include/yices.h: 1753
if hasattr(_libs['yices'], 'yices_bvle_atom'):
    yices_bvle_atom = _libs['yices'].yices_bvle_atom
    yices_bvle_atom.argtypes = [term_t, term_t]
    yices_bvle_atom.restype = term_t

# /usr/include/yices.h: 1754
if hasattr(_libs['yices'], 'yices_bvlt_atom'):
    yices_bvlt_atom = _libs['yices'].yices_bvlt_atom
    yices_bvlt_atom.argtypes = [term_t, term_t]
    yices_bvlt_atom.restype = term_t

# /usr/include/yices.h: 1760
if hasattr(_libs['yices'], 'yices_bvsge_atom'):
    yices_bvsge_atom = _libs['yices'].yices_bvsge_atom
    yices_bvsge_atom.argtypes = [term_t, term_t]
    yices_bvsge_atom.restype = term_t

# /usr/include/yices.h: 1761
if hasattr(_libs['yices'], 'yices_bvsgt_atom'):
    yices_bvsgt_atom = _libs['yices'].yices_bvsgt_atom
    yices_bvsgt_atom.argtypes = [term_t, term_t]
    yices_bvsgt_atom.restype = term_t

# /usr/include/yices.h: 1762
if hasattr(_libs['yices'], 'yices_bvsle_atom'):
    yices_bvsle_atom = _libs['yices'].yices_bvsle_atom
    yices_bvsle_atom.argtypes = [term_t, term_t]
    yices_bvsle_atom.restype = term_t

# /usr/include/yices.h: 1763
if hasattr(_libs['yices'], 'yices_bvslt_atom'):
    yices_bvslt_atom = _libs['yices'].yices_bvslt_atom
    yices_bvslt_atom.argtypes = [term_t, term_t]
    yices_bvslt_atom.restype = term_t

# /usr/include/yices.h: 1781
if hasattr(_libs['yices'], 'yices_parse_type'):
    yices_parse_type = _libs['yices'].yices_parse_type
    yices_parse_type.argtypes = [String]
    yices_parse_type.restype = type_t

# /usr/include/yices.h: 1782
if hasattr(_libs['yices'], 'yices_parse_term'):
    yices_parse_term = _libs['yices'].yices_parse_term
    yices_parse_term.argtypes = [String]
    yices_parse_term.restype = term_t

# /usr/include/yices.h: 1812
if hasattr(_libs['yices'], 'yices_subst_term'):
    yices_subst_term = _libs['yices'].yices_subst_term
    yices_subst_term.argtypes = [c_uint32, POINTER(term_t), POINTER(term_t), term_t]
    yices_subst_term.restype = term_t

# /usr/include/yices.h: 1835
if hasattr(_libs['yices'], 'yices_subst_term_array'):
    yices_subst_term_array = _libs['yices'].yices_subst_term_array
    yices_subst_term_array.argtypes = [c_uint32, POINTER(term_t), POINTER(term_t), c_uint32, POINTER(term_t)]
    yices_subst_term_array.restype = c_int32

# /usr/include/yices.h: 1878
if hasattr(_libs['yices'], 'yices_set_type_name'):
    yices_set_type_name = _libs['yices'].yices_set_type_name
    yices_set_type_name.argtypes = [type_t, String]
    yices_set_type_name.restype = c_int32

# /usr/include/yices.h: 1879
if hasattr(_libs['yices'], 'yices_set_term_name'):
    yices_set_term_name = _libs['yices'].yices_set_term_name
    yices_set_term_name.argtypes = [term_t, String]
    yices_set_term_name.restype = c_int32

# /usr/include/yices.h: 1889
if hasattr(_libs['yices'], 'yices_remove_type_name'):
    yices_remove_type_name = _libs['yices'].yices_remove_type_name
    yices_remove_type_name.argtypes = [String]
    yices_remove_type_name.restype = None

# /usr/include/yices.h: 1890
if hasattr(_libs['yices'], 'yices_remove_term_name'):
    yices_remove_term_name = _libs['yices'].yices_remove_term_name
    yices_remove_term_name.argtypes = [String]
    yices_remove_term_name.restype = None

# /usr/include/yices.h: 1897
if hasattr(_libs['yices'], 'yices_get_type_by_name'):
    yices_get_type_by_name = _libs['yices'].yices_get_type_by_name
    yices_get_type_by_name.argtypes = [String]
    yices_get_type_by_name.restype = type_t

# /usr/include/yices.h: 1898
if hasattr(_libs['yices'], 'yices_get_term_by_name'):
    yices_get_term_by_name = _libs['yices'].yices_get_term_by_name
    yices_get_term_by_name.argtypes = [String]
    yices_get_term_by_name.restype = term_t

# /usr/include/yices.h: 1914
if hasattr(_libs['yices'], 'yices_clear_type_name'):
    yices_clear_type_name = _libs['yices'].yices_clear_type_name
    yices_clear_type_name.argtypes = [type_t]
    yices_clear_type_name.restype = c_int32

# /usr/include/yices.h: 1915
if hasattr(_libs['yices'], 'yices_clear_term_name'):
    yices_clear_term_name = _libs['yices'].yices_clear_term_name
    yices_clear_term_name.argtypes = [term_t]
    yices_clear_term_name.restype = c_int32

# /usr/include/yices.h: 1925
if hasattr(_libs['yices'], 'yices_get_type_name'):
    yices_get_type_name = _libs['yices'].yices_get_type_name
    yices_get_type_name.argtypes = [type_t]
    if sizeof(c_int) == sizeof(c_void_p):
        yices_get_type_name.restype = ReturnString
    else:
        yices_get_type_name.restype = String
        yices_get_type_name.errcheck = ReturnString

# /usr/include/yices.h: 1926
if hasattr(_libs['yices'], 'yices_get_term_name'):
    yices_get_term_name = _libs['yices'].yices_get_term_name
    yices_get_term_name.argtypes = [term_t]
    if sizeof(c_int) == sizeof(c_void_p):
        yices_get_term_name.restype = ReturnString
    else:
        yices_get_term_name.restype = String
        yices_get_term_name.errcheck = ReturnString

# /usr/include/yices.h: 1943
if hasattr(_libs['yices'], 'yices_type_of_term'):
    yices_type_of_term = _libs['yices'].yices_type_of_term
    yices_type_of_term.argtypes = [term_t]
    yices_type_of_term.restype = type_t

# /usr/include/yices.h: 1958
if hasattr(_libs['yices'], 'yices_term_is_bool'):
    yices_term_is_bool = _libs['yices'].yices_term_is_bool
    yices_term_is_bool.argtypes = [term_t]
    yices_term_is_bool.restype = c_int32

# /usr/include/yices.h: 1960
if hasattr(_libs['yices'], 'yices_term_is_int'):
    yices_term_is_int = _libs['yices'].yices_term_is_int
    yices_term_is_int.argtypes = [term_t]
    yices_term_is_int.restype = c_int32

# /usr/include/yices.h: 1961
if hasattr(_libs['yices'], 'yices_term_is_real'):
    yices_term_is_real = _libs['yices'].yices_term_is_real
    yices_term_is_real.argtypes = [term_t]
    yices_term_is_real.restype = c_int32

# /usr/include/yices.h: 1962
if hasattr(_libs['yices'], 'yices_term_is_arithmetic'):
    yices_term_is_arithmetic = _libs['yices'].yices_term_is_arithmetic
    yices_term_is_arithmetic.argtypes = [term_t]
    yices_term_is_arithmetic.restype = c_int32

# /usr/include/yices.h: 1963
if hasattr(_libs['yices'], 'yices_term_is_bitvector'):
    yices_term_is_bitvector = _libs['yices'].yices_term_is_bitvector
    yices_term_is_bitvector.argtypes = [term_t]
    yices_term_is_bitvector.restype = c_int32

# /usr/include/yices.h: 1964
if hasattr(_libs['yices'], 'yices_term_is_tuple'):
    yices_term_is_tuple = _libs['yices'].yices_term_is_tuple
    yices_term_is_tuple.argtypes = [term_t]
    yices_term_is_tuple.restype = c_int32

# /usr/include/yices.h: 1965
if hasattr(_libs['yices'], 'yices_term_is_function'):
    yices_term_is_function = _libs['yices'].yices_term_is_function
    yices_term_is_function.argtypes = [term_t]
    yices_term_is_function.restype = c_int32

# /usr/include/yices.h: 1966
if hasattr(_libs['yices'], 'yices_term_is_scalar'):
    yices_term_is_scalar = _libs['yices'].yices_term_is_scalar
    yices_term_is_scalar.argtypes = [term_t]
    yices_term_is_scalar.restype = c_int32

# /usr/include/yices.h: 1981
if hasattr(_libs['yices'], 'yices_term_bitsize'):
    yices_term_bitsize = _libs['yices'].yices_term_bitsize
    yices_term_bitsize.argtypes = [term_t]
    yices_term_bitsize.restype = c_uint32

# /usr/include/yices.h: 1990
if hasattr(_libs['yices'], 'yices_term_is_ground'):
    yices_term_is_ground = _libs['yices'].yices_term_is_ground
    yices_term_is_ground.argtypes = [term_t]
    yices_term_is_ground.restype = c_int32

# /usr/include/yices.h: 2107
if hasattr(_libs['yices'], 'yices_term_is_atomic'):
    yices_term_is_atomic = _libs['yices'].yices_term_is_atomic
    yices_term_is_atomic.argtypes = [term_t]
    yices_term_is_atomic.restype = c_int32

# /usr/include/yices.h: 2108
if hasattr(_libs['yices'], 'yices_term_is_composite'):
    yices_term_is_composite = _libs['yices'].yices_term_is_composite
    yices_term_is_composite.argtypes = [term_t]
    yices_term_is_composite.restype = c_int32

# /usr/include/yices.h: 2109
if hasattr(_libs['yices'], 'yices_term_is_projection'):
    yices_term_is_projection = _libs['yices'].yices_term_is_projection
    yices_term_is_projection.argtypes = [term_t]
    yices_term_is_projection.restype = c_int32

# /usr/include/yices.h: 2110
if hasattr(_libs['yices'], 'yices_term_is_sum'):
    yices_term_is_sum = _libs['yices'].yices_term_is_sum
    yices_term_is_sum.argtypes = [term_t]
    yices_term_is_sum.restype = c_int32

# /usr/include/yices.h: 2111
if hasattr(_libs['yices'], 'yices_term_is_bvsum'):
    yices_term_is_bvsum = _libs['yices'].yices_term_is_bvsum
    yices_term_is_bvsum.argtypes = [term_t]
    yices_term_is_bvsum.restype = c_int32

# /usr/include/yices.h: 2112
if hasattr(_libs['yices'], 'yices_term_is_product'):
    yices_term_is_product = _libs['yices'].yices_term_is_product
    yices_term_is_product.argtypes = [term_t]
    yices_term_is_product.restype = c_int32

# /usr/include/yices.h: 2176
if hasattr(_libs['yices'], 'yices_term_constructor'):
    yices_term_constructor = _libs['yices'].yices_term_constructor
    yices_term_constructor.argtypes = [term_t]
    yices_term_constructor.restype = term_constructor_t

# /usr/include/yices.h: 2189
if hasattr(_libs['yices'], 'yices_term_num_children'):
    yices_term_num_children = _libs['yices'].yices_term_num_children
    yices_term_num_children.argtypes = [term_t]
    yices_term_num_children.restype = c_int32

# /usr/include/yices.h: 2206
if hasattr(_libs['yices'], 'yices_term_child'):
    yices_term_child = _libs['yices'].yices_term_child
    yices_term_child.argtypes = [term_t, c_int32]
    yices_term_child.restype = term_t

# /usr/include/yices.h: 2222
if hasattr(_libs['yices'], 'yices_proj_index'):
    yices_proj_index = _libs['yices'].yices_proj_index
    yices_proj_index.argtypes = [term_t]
    yices_proj_index.restype = c_int32

# /usr/include/yices.h: 2223
if hasattr(_libs['yices'], 'yices_proj_arg'):
    yices_proj_arg = _libs['yices'].yices_proj_arg
    yices_proj_arg.argtypes = [term_t]
    yices_proj_arg.restype = term_t

# /usr/include/yices.h: 2242
if hasattr(_libs['yices'], 'yices_bool_const_value'):
    yices_bool_const_value = _libs['yices'].yices_bool_const_value
    yices_bool_const_value.argtypes = [term_t, POINTER(c_int32)]
    yices_bool_const_value.restype = c_int32

# /usr/include/yices.h: 2243
if hasattr(_libs['yices'], 'yices_bv_const_value'):
    yices_bv_const_value = _libs['yices'].yices_bv_const_value
    yices_bv_const_value.argtypes = [term_t, POINTER(c_int32)]
    yices_bv_const_value.restype = c_int32

# /usr/include/yices.h: 2244
if hasattr(_libs['yices'], 'yices_scalar_const_value'):
    yices_scalar_const_value = _libs['yices'].yices_scalar_const_value
    yices_scalar_const_value.argtypes = [term_t, POINTER(c_int32)]
    yices_scalar_const_value.restype = c_int32

# /usr/include/yices.h: 2272
if hasattr(_libs['yices'], 'yices_bvsum_component'):
    yices_bvsum_component = _libs['yices'].yices_bvsum_component
    yices_bvsum_component.argtypes = [term_t, c_int32, POINTER(c_int32), POINTER(term_t)]
    yices_bvsum_component.restype = c_int32

# /usr/include/yices.h: 2290
if hasattr(_libs['yices'], 'yices_product_component'):
    yices_product_component = _libs['yices'].yices_product_component
    yices_product_component.argtypes = [term_t, c_int32, POINTER(term_t), POINTER(c_uint32)]
    yices_product_component.restype = c_int32

# /usr/include/yices.h: 2352
if hasattr(_libs['yices'], 'yices_num_terms'):
    yices_num_terms = _libs['yices'].yices_num_terms
    yices_num_terms.argtypes = []
    yices_num_terms.restype = c_uint32

# /usr/include/yices.h: 2353
if hasattr(_libs['yices'], 'yices_num_types'):
    yices_num_types = _libs['yices'].yices_num_types
    yices_num_types.argtypes = []
    yices_num_types.restype = c_uint32

# /usr/include/yices.h: 2367
if hasattr(_libs['yices'], 'yices_incref_term'):
    yices_incref_term = _libs['yices'].yices_incref_term
    yices_incref_term.argtypes = [term_t]
    yices_incref_term.restype = c_int32

# /usr/include/yices.h: 2368
if hasattr(_libs['yices'], 'yices_decref_term'):
    yices_decref_term = _libs['yices'].yices_decref_term
    yices_decref_term.argtypes = [term_t]
    yices_decref_term.restype = c_int32

# /usr/include/yices.h: 2369
if hasattr(_libs['yices'], 'yices_incref_type'):
    yices_incref_type = _libs['yices'].yices_incref_type
    yices_incref_type.argtypes = [type_t]
    yices_incref_type.restype = c_int32

# /usr/include/yices.h: 2370
if hasattr(_libs['yices'], 'yices_decref_type'):
    yices_decref_type = _libs['yices'].yices_decref_type
    yices_decref_type.argtypes = [type_t]
    yices_decref_type.restype = c_int32

# /usr/include/yices.h: 2379
if hasattr(_libs['yices'], 'yices_num_posref_terms'):
    yices_num_posref_terms = _libs['yices'].yices_num_posref_terms
    yices_num_posref_terms.argtypes = []
    yices_num_posref_terms.restype = c_uint32

# /usr/include/yices.h: 2380
if hasattr(_libs['yices'], 'yices_num_posref_types'):
    yices_num_posref_types = _libs['yices'].yices_num_posref_types
    yices_num_posref_types.argtypes = []
    yices_num_posref_types.restype = c_uint32

# /usr/include/yices.h: 2406
if hasattr(_libs['yices'], 'yices_garbage_collect'):
    yices_garbage_collect = _libs['yices'].yices_garbage_collect
    yices_garbage_collect.argtypes = [POINTER(term_t), c_uint32, POINTER(type_t), c_uint32, c_int32]
    yices_garbage_collect.restype = None

# /usr/include/yices.h: 2491
if hasattr(_libs['yices'], 'yices_new_config'):
    yices_new_config = _libs['yices'].yices_new_config
    yices_new_config.argtypes = []
    yices_new_config.restype = POINTER(ctx_config_t)

# /usr/include/yices.h: 2497
if hasattr(_libs['yices'], 'yices_free_config'):
    yices_free_config = _libs['yices'].yices_free_config
    yices_free_config.argtypes = [POINTER(ctx_config_t)]
    yices_free_config.restype = None

# /usr/include/yices.h: 2559
if hasattr(_libs['yices'], 'yices_set_config'):
    yices_set_config = _libs['yices'].yices_set_config
    yices_set_config.argtypes = [POINTER(ctx_config_t), String, String]
    yices_set_config.restype = c_int32

# /usr/include/yices.h: 2631
if hasattr(_libs['yices'], 'yices_default_config_for_logic'):
    yices_default_config_for_logic = _libs['yices'].yices_default_config_for_logic
    yices_default_config_for_logic.argtypes = [POINTER(ctx_config_t), String]
    yices_default_config_for_logic.restype = c_int32

# /usr/include/yices.h: 2702
if hasattr(_libs['yices'], 'yices_new_context'):
    yices_new_context = _libs['yices'].yices_new_context
    yices_new_context.argtypes = [POINTER(ctx_config_t)]
    yices_new_context.restype = POINTER(context_t)

# /usr/include/yices.h: 2708
if hasattr(_libs['yices'], 'yices_free_context'):
    yices_free_context = _libs['yices'].yices_free_context
    yices_free_context.argtypes = [POINTER(context_t)]
    yices_free_context.restype = None

# /usr/include/yices.h: 2724
if hasattr(_libs['yices'], 'yices_context_status'):
    yices_context_status = _libs['yices'].yices_context_status
    yices_context_status.argtypes = [POINTER(context_t)]
    yices_context_status.restype = smt_status_t

# /usr/include/yices.h: 2731
if hasattr(_libs['yices'], 'yices_reset_context'):
    yices_reset_context = _libs['yices'].yices_reset_context
    yices_reset_context.argtypes = [POINTER(context_t)]
    yices_reset_context.restype = None

# /usr/include/yices.h: 2745
if hasattr(_libs['yices'], 'yices_push'):
    yices_push = _libs['yices'].yices_push
    yices_push.argtypes = [POINTER(context_t)]
    yices_push.restype = c_int32

# /usr/include/yices.h: 2760
if hasattr(_libs['yices'], 'yices_pop'):
    yices_pop = _libs['yices'].yices_pop
    yices_pop.argtypes = [POINTER(context_t)]
    yices_pop.restype = c_int32

# /usr/include/yices.h: 2806
if hasattr(_libs['yices'], 'yices_context_enable_option'):
    yices_context_enable_option = _libs['yices'].yices_context_enable_option
    yices_context_enable_option.argtypes = [POINTER(context_t), String]
    yices_context_enable_option.restype = c_int32

# /usr/include/yices.h: 2807
if hasattr(_libs['yices'], 'yices_context_disable_option'):
    yices_context_disable_option = _libs['yices'].yices_context_disable_option
    yices_context_disable_option.argtypes = [POINTER(context_t), String]
    yices_context_disable_option.restype = c_int32

# /usr/include/yices.h: 2842
if hasattr(_libs['yices'], 'yices_assert_formula'):
    yices_assert_formula = _libs['yices'].yices_assert_formula
    yices_assert_formula.argtypes = [POINTER(context_t), term_t]
    yices_assert_formula.restype = c_int32

# /usr/include/yices.h: 2854
if hasattr(_libs['yices'], 'yices_assert_formulas'):
    yices_assert_formulas = _libs['yices'].yices_assert_formulas
    yices_assert_formulas.argtypes = [POINTER(context_t), c_uint32, POINTER(term_t)]
    yices_assert_formulas.restype = c_int32

# /usr/include/yices.h: 2892
if hasattr(_libs['yices'], 'yices_check_context'):
    yices_check_context = _libs['yices'].yices_check_context
    yices_check_context.argtypes = [POINTER(context_t), POINTER(param_t)]
    yices_check_context.restype = smt_status_t

# /usr/include/yices.h: 2914
if hasattr(_libs['yices'], 'yices_assert_blocking_clause'):
    yices_assert_blocking_clause = _libs['yices'].yices_assert_blocking_clause
    yices_assert_blocking_clause.argtypes = [POINTER(context_t)]
    yices_assert_blocking_clause.restype = c_int32

# /usr/include/yices.h: 2925
if hasattr(_libs['yices'], 'yices_stop_search'):
    yices_stop_search = _libs['yices'].yices_stop_search
    yices_stop_search.argtypes = [POINTER(context_t)]
    yices_stop_search.restype = None

# /usr/include/yices.h: 2958
if hasattr(_libs['yices'], 'yices_new_param_record'):
    yices_new_param_record = _libs['yices'].yices_new_param_record
    yices_new_param_record.argtypes = []
    yices_new_param_record.restype = POINTER(param_t)

# /usr/include/yices.h: 2974
if hasattr(_libs['yices'], 'yices_set_param'):
    yices_set_param = _libs['yices'].yices_set_param
    yices_set_param.argtypes = [POINTER(param_t), String, String]
    yices_set_param.restype = c_int32

# /usr/include/yices.h: 2980
if hasattr(_libs['yices'], 'yices_free_param_record'):
    yices_free_param_record = _libs['yices'].yices_free_param_record
    yices_free_param_record.argtypes = [POINTER(param_t)]
    yices_free_param_record.restype = None

# /usr/include/yices.h: 3023
if hasattr(_libs['yices'], 'yices_get_model'):
    yices_get_model = _libs['yices'].yices_get_model
    yices_get_model.argtypes = [POINTER(context_t), c_int32]
    yices_get_model.restype = POINTER(model_t)

# /usr/include/yices.h: 3029
if hasattr(_libs['yices'], 'yices_free_model'):
    yices_free_model = _libs['yices'].yices_free_model
    yices_free_model.argtypes = [POINTER(model_t)]
    yices_free_model.restype = None

# /usr/include/yices.h: 3053
if hasattr(_libs['yices'], 'yices_model_from_map'):
    yices_model_from_map = _libs['yices'].yices_model_from_map
    yices_model_from_map.argtypes = [c_uint32, POINTER(term_t), POINTER(term_t)]
    yices_model_from_map.restype = POINTER(model_t)

# /usr/include/yices.h: 3106
if hasattr(_libs['yices'], 'yices_get_bool_value'):
    yices_get_bool_value = _libs['yices'].yices_get_bool_value
    yices_get_bool_value.argtypes = [POINTER(model_t), term_t, POINTER(c_int32)]
    yices_get_bool_value.restype = c_int32

# /usr/include/yices.h: 3121
if hasattr(_libs['yices'], 'yices_get_int32_value'):
    yices_get_int32_value = _libs['yices'].yices_get_int32_value
    yices_get_int32_value.argtypes = [POINTER(model_t), term_t, POINTER(c_int32)]
    yices_get_int32_value.restype = c_int32

# /usr/include/yices.h: 3122
if hasattr(_libs['yices'], 'yices_get_int64_value'):
    yices_get_int64_value = _libs['yices'].yices_get_int64_value
    yices_get_int64_value.argtypes = [POINTER(model_t), term_t, POINTER(c_int64)]
    yices_get_int64_value.restype = c_int32

# /usr/include/yices.h: 3123
if hasattr(_libs['yices'], 'yices_get_rational32_value'):
    yices_get_rational32_value = _libs['yices'].yices_get_rational32_value
    yices_get_rational32_value.argtypes = [POINTER(model_t), term_t, POINTER(c_int32), POINTER(c_uint32)]
    yices_get_rational32_value.restype = c_int32

# /usr/include/yices.h: 3124
if hasattr(_libs['yices'], 'yices_get_rational64_value'):
    yices_get_rational64_value = _libs['yices'].yices_get_rational64_value
    yices_get_rational64_value.argtypes = [POINTER(model_t), term_t, POINTER(c_int64), POINTER(c_uint64)]
    yices_get_rational64_value.restype = c_int32

# /usr/include/yices.h: 3125
if hasattr(_libs['yices'], 'yices_get_double_value'):
    yices_get_double_value = _libs['yices'].yices_get_double_value
    yices_get_double_value.argtypes = [POINTER(model_t), term_t, POINTER(c_double)]
    yices_get_double_value.restype = c_int32

# /usr/include/yices.h: 3148
if hasattr(_libs['yices'], 'yices_get_bv_value'):
    yices_get_bv_value = _libs['yices'].yices_get_bv_value
    yices_get_bv_value.argtypes = [POINTER(model_t), term_t, POINTER(c_int32)]
    yices_get_bv_value.restype = c_int32

# /usr/include/yices.h: 3168
if hasattr(_libs['yices'], 'yices_get_scalar_value'):
    yices_get_scalar_value = _libs['yices'].yices_get_scalar_value
    yices_get_scalar_value.argtypes = [POINTER(model_t), term_t, POINTER(c_int32)]
    yices_get_scalar_value.restype = c_int32

# /usr/include/yices.h: 3245
if hasattr(_libs['yices'], 'yices_init_yval_vector'):
    yices_init_yval_vector = _libs['yices'].yices_init_yval_vector
    yices_init_yval_vector.argtypes = [POINTER(yval_vector_t)]
    yices_init_yval_vector.restype = None

# /usr/include/yices.h: 3246
if hasattr(_libs['yices'], 'yices_delete_yval_vector'):
    yices_delete_yval_vector = _libs['yices'].yices_delete_yval_vector
    yices_delete_yval_vector.argtypes = [POINTER(yval_vector_t)]
    yices_delete_yval_vector.restype = None

# /usr/include/yices.h: 3247
if hasattr(_libs['yices'], 'yices_reset_yval_vector'):
    yices_reset_yval_vector = _libs['yices'].yices_reset_yval_vector
    yices_reset_yval_vector.argtypes = [POINTER(yval_vector_t)]
    yices_reset_yval_vector.restype = None

# /usr/include/yices.h: 3270
if hasattr(_libs['yices'], 'yices_get_value'):
    yices_get_value = _libs['yices'].yices_get_value
    yices_get_value.argtypes = [POINTER(model_t), term_t, POINTER(yval_t)]
    yices_get_value.restype = c_int32

# /usr/include/yices.h: 3291
if hasattr(_libs['yices'], 'yices_val_is_int32'):
    yices_val_is_int32 = _libs['yices'].yices_val_is_int32
    yices_val_is_int32.argtypes = [POINTER(model_t), POINTER(yval_t)]
    yices_val_is_int32.restype = c_int32

# /usr/include/yices.h: 3292
if hasattr(_libs['yices'], 'yices_val_is_int64'):
    yices_val_is_int64 = _libs['yices'].yices_val_is_int64
    yices_val_is_int64.argtypes = [POINTER(model_t), POINTER(yval_t)]
    yices_val_is_int64.restype = c_int32

# /usr/include/yices.h: 3293
if hasattr(_libs['yices'], 'yices_val_is_rational32'):
    yices_val_is_rational32 = _libs['yices'].yices_val_is_rational32
    yices_val_is_rational32.argtypes = [POINTER(model_t), POINTER(yval_t)]
    yices_val_is_rational32.restype = c_int32

# /usr/include/yices.h: 3294
if hasattr(_libs['yices'], 'yices_val_is_rational64'):
    yices_val_is_rational64 = _libs['yices'].yices_val_is_rational64
    yices_val_is_rational64.argtypes = [POINTER(model_t), POINTER(yval_t)]
    yices_val_is_rational64.restype = c_int32

# /usr/include/yices.h: 3295
if hasattr(_libs['yices'], 'yices_val_is_integer'):
    yices_val_is_integer = _libs['yices'].yices_val_is_integer
    yices_val_is_integer.argtypes = [POINTER(model_t), POINTER(yval_t)]
    yices_val_is_integer.restype = c_int32

# /usr/include/yices.h: 3303
if hasattr(_libs['yices'], 'yices_val_bitsize'):
    yices_val_bitsize = _libs['yices'].yices_val_bitsize
    yices_val_bitsize.argtypes = [POINTER(model_t), POINTER(yval_t)]
    yices_val_bitsize.restype = c_uint32

# /usr/include/yices.h: 3304
if hasattr(_libs['yices'], 'yices_val_tuple_arity'):
    yices_val_tuple_arity = _libs['yices'].yices_val_tuple_arity
    yices_val_tuple_arity.argtypes = [POINTER(model_t), POINTER(yval_t)]
    yices_val_tuple_arity.restype = c_uint32

# /usr/include/yices.h: 3305
if hasattr(_libs['yices'], 'yices_val_mapping_arity'):
    yices_val_mapping_arity = _libs['yices'].yices_val_mapping_arity
    yices_val_mapping_arity.argtypes = [POINTER(model_t), POINTER(yval_t)]
    yices_val_mapping_arity.restype = c_uint32

# /usr/include/yices.h: 3313
if hasattr(_libs['yices'], 'yices_val_function_arity'):
    yices_val_function_arity = _libs['yices'].yices_val_function_arity
    yices_val_function_arity.argtypes = [POINTER(model_t), POINTER(yval_t)]
    yices_val_function_arity.restype = c_uint32

# /usr/include/yices.h: 3323
if hasattr(_libs['yices'], 'yices_val_get_bool'):
    yices_val_get_bool = _libs['yices'].yices_val_get_bool
    yices_val_get_bool.argtypes = [POINTER(model_t), POINTER(yval_t), POINTER(c_int32)]
    yices_val_get_bool.restype = c_int32

# /usr/include/yices.h: 3335
if hasattr(_libs['yices'], 'yices_val_get_int32'):
    yices_val_get_int32 = _libs['yices'].yices_val_get_int32
    yices_val_get_int32.argtypes = [POINTER(model_t), POINTER(yval_t), POINTER(c_int32)]
    yices_val_get_int32.restype = c_int32

# /usr/include/yices.h: 3336
if hasattr(_libs['yices'], 'yices_val_get_int64'):
    yices_val_get_int64 = _libs['yices'].yices_val_get_int64
    yices_val_get_int64.argtypes = [POINTER(model_t), POINTER(yval_t), POINTER(c_int64)]
    yices_val_get_int64.restype = c_int32

# /usr/include/yices.h: 3337
if hasattr(_libs['yices'], 'yices_val_get_rational32'):
    yices_val_get_rational32 = _libs['yices'].yices_val_get_rational32
    yices_val_get_rational32.argtypes = [POINTER(model_t), POINTER(yval_t), POINTER(c_int32), POINTER(c_uint32)]
    yices_val_get_rational32.restype = c_int32

# /usr/include/yices.h: 3338
if hasattr(_libs['yices'], 'yices_val_get_rational64'):
    yices_val_get_rational64 = _libs['yices'].yices_val_get_rational64
    yices_val_get_rational64.argtypes = [POINTER(model_t), POINTER(yval_t), POINTER(c_int64), POINTER(c_uint64)]
    yices_val_get_rational64.restype = c_int32

# /usr/include/yices.h: 3341
if hasattr(_libs['yices'], 'yices_val_get_double'):
    yices_val_get_double = _libs['yices'].yices_val_get_double
    yices_val_get_double.argtypes = [POINTER(model_t), POINTER(yval_t), POINTER(c_double)]
    yices_val_get_double.restype = c_int32

# /usr/include/yices.h: 3357
if hasattr(_libs['yices'], 'yices_val_get_bv'):
    yices_val_get_bv = _libs['yices'].yices_val_get_bv
    yices_val_get_bv.argtypes = [POINTER(model_t), POINTER(yval_t), POINTER(c_int32)]
    yices_val_get_bv.restype = c_int32

# /usr/include/yices.h: 3365
if hasattr(_libs['yices'], 'yices_val_get_scalar'):
    yices_val_get_scalar = _libs['yices'].yices_val_get_scalar
    yices_val_get_scalar.argtypes = [POINTER(model_t), POINTER(yval_t), POINTER(c_int32), POINTER(type_t)]
    yices_val_get_scalar.restype = c_int32

# /usr/include/yices.h: 3376
if hasattr(_libs['yices'], 'yices_val_expand_tuple'):
    yices_val_expand_tuple = _libs['yices'].yices_val_expand_tuple
    yices_val_expand_tuple.argtypes = [POINTER(model_t), POINTER(yval_t), POINTER(yval_t)]
    yices_val_expand_tuple.restype = c_int32

# /usr/include/yices.h: 3390
if hasattr(_libs['yices'], 'yices_val_expand_function'):
    yices_val_expand_function = _libs['yices'].yices_val_expand_function
    yices_val_expand_function.argtypes = [POINTER(model_t), POINTER(yval_t), POINTER(yval_t), POINTER(yval_vector_t)]
    yices_val_expand_function.restype = c_int32

# /usr/include/yices.h: 3403
if hasattr(_libs['yices'], 'yices_val_expand_mapping'):
    yices_val_expand_mapping = _libs['yices'].yices_val_expand_mapping
    yices_val_expand_mapping.argtypes = [POINTER(model_t), POINTER(yval_t), POINTER(yval_t), POINTER(yval_t)]
    yices_val_expand_mapping.restype = c_int32

# /usr/include/yices.h: 3421
if hasattr(_libs['yices'], 'yices_formula_true_in_model'):
    yices_formula_true_in_model = _libs['yices'].yices_formula_true_in_model
    yices_formula_true_in_model.argtypes = [POINTER(model_t), term_t]
    yices_formula_true_in_model.restype = c_int32

# /usr/include/yices.h: 3437
if hasattr(_libs['yices'], 'yices_formulas_true_in_model'):
    yices_formulas_true_in_model = _libs['yices'].yices_formulas_true_in_model
    yices_formulas_true_in_model.argtypes = [POINTER(model_t), c_uint32, POINTER(term_t)]
    yices_formulas_true_in_model.restype = c_int32

# /usr/include/yices.h: 3473
if hasattr(_libs['yices'], 'yices_get_value_as_term'):
    yices_get_value_as_term = _libs['yices'].yices_get_value_as_term
    yices_get_value_as_term.argtypes = [POINTER(model_t), term_t]
    yices_get_value_as_term.restype = term_t

# /usr/include/yices.h: 3488
if hasattr(_libs['yices'], 'yices_term_array_value'):
    yices_term_array_value = _libs['yices'].yices_term_array_value
    yices_term_array_value.argtypes = [POINTER(model_t), c_uint32, POINTER(term_t), POINTER(term_t)]
    yices_term_array_value.restype = c_int32

# /usr/include/yices.h: 3532
if hasattr(_libs['yices'], 'yices_implicant_for_formula'):
    yices_implicant_for_formula = _libs['yices'].yices_implicant_for_formula
    yices_implicant_for_formula.argtypes = [POINTER(model_t), term_t, POINTER(term_vector_t)]
    yices_implicant_for_formula.restype = c_int32

# /usr/include/yices.h: 3551
if hasattr(_libs['yices'], 'yices_implicant_for_formulas'):
    yices_implicant_for_formulas = _libs['yices'].yices_implicant_for_formulas
    yices_implicant_for_formulas.argtypes = [POINTER(model_t), c_uint32, POINTER(term_t), POINTER(term_vector_t)]
    yices_implicant_for_formulas.restype = c_int32

# /usr/include/yices.h: 3613
if hasattr(_libs['yices'], 'yices_generalize_model'):
    yices_generalize_model = _libs['yices'].yices_generalize_model
    yices_generalize_model.argtypes = [POINTER(model_t), term_t, c_uint32, POINTER(term_t), yices_gen_mode_t, POINTER(term_vector_t)]
    yices_generalize_model.restype = c_int32

# /usr/include/yices.h: 3620
if hasattr(_libs['yices'], 'yices_generalize_model_array'):
    yices_generalize_model_array = _libs['yices'].yices_generalize_model_array
    yices_generalize_model_array.argtypes = [POINTER(model_t), c_uint32, POINTER(term_t), c_uint32, POINTER(term_t), yices_gen_mode_t, POINTER(term_vector_t)]
    yices_generalize_model_array.restype = c_int32

# /usr/include/yices.h: 3666
if hasattr(_libs['yices'], 'yices_pp_type'):
    yices_pp_type = _libs['yices'].yices_pp_type
    yices_pp_type.argtypes = [POINTER(FILE), type_t, c_uint32, c_uint32, c_uint32]
    yices_pp_type.restype = c_int32

# /usr/include/yices.h: 3667
if hasattr(_libs['yices'], 'yices_pp_term'):
    yices_pp_term = _libs['yices'].yices_pp_term
    yices_pp_term.argtypes = [POINTER(FILE), term_t, c_uint32, c_uint32, c_uint32]
    yices_pp_term.restype = c_int32

# /usr/include/yices.h: 3702
if hasattr(_libs['yices'], 'yices_pp_term_array'):
    yices_pp_term_array = _libs['yices'].yices_pp_term_array
    yices_pp_term_array.argtypes = [POINTER(FILE), c_uint32, POINTER(term_t), c_uint32, c_uint32, c_uint32, c_int32]
    yices_pp_term_array.restype = c_int32

# /usr/include/yices.h: 3723
if hasattr(_libs['yices'], 'yices_print_model'):
    yices_print_model = _libs['yices'].yices_print_model
    yices_print_model.argtypes = [POINTER(FILE), POINTER(model_t)]
    yices_print_model.restype = None

# /usr/include/yices.h: 3740
if hasattr(_libs['yices'], 'yices_pp_model'):
    yices_pp_model = _libs['yices'].yices_pp_model
    yices_pp_model.argtypes = [POINTER(FILE), POINTER(model_t), c_uint32, c_uint32, c_uint32]
    yices_pp_model.restype = c_int32

# /usr/include/yices.h: 3760
if hasattr(_libs['yices'], 'yices_type_to_string'):
    yices_type_to_string = _libs['yices'].yices_type_to_string
    yices_type_to_string.argtypes = [type_t, c_uint32, c_uint32, c_uint32]
    if sizeof(c_int) == sizeof(c_void_p):
        yices_type_to_string.restype = ReturnString
    else:
        yices_type_to_string.restype = String
        yices_type_to_string.errcheck = ReturnString

# /usr/include/yices.h: 3761
if hasattr(_libs['yices'], 'yices_term_to_string'):
    yices_term_to_string = _libs['yices'].yices_term_to_string
    yices_term_to_string.argtypes = [term_t, c_uint32, c_uint32, c_uint32]
    if sizeof(c_int) == sizeof(c_void_p):
        yices_term_to_string.restype = ReturnString
    else:
        yices_term_to_string.restype = String
        yices_term_to_string.errcheck = ReturnString

# /usr/include/yices.h: 3771
if hasattr(_libs['yices'], 'yices_model_to_string'):
    yices_model_to_string = _libs['yices'].yices_model_to_string
    yices_model_to_string.argtypes = [POINTER(model_t), c_uint32, c_uint32, c_uint32]
    if sizeof(c_int) == sizeof(c_void_p):
        yices_model_to_string.restype = ReturnString
    else:
        yices_model_to_string.restype = String
        yices_model_to_string.errcheck = ReturnString

# /usr/include/yices.h: 73
try:
    __YICES_VERSION = 2
except:
    pass

# /usr/include/yices.h: 74
try:
    __YICES_VERSION_MAJOR = 3
except:
    pass

# /usr/include/yices.h: 75
try:
    __YICES_VERSION_PATCHLEVEL = 0
except:
    pass

# No inserted files

